=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-06-01 04:09:48 +0000
+++ drizzled/Makefile.am	2009-06-08 06:23:32 +0000
@@ -604,6 +604,7 @@
 		stacktrace.cc \
 		strfunc.cc \
 		table.cc \
+		table_list.cc \
                 table_map_iterator.cc \
 		temporal.cc \
 		temporal_format.cc \

=== modified file 'drizzled/common.h'
--- drizzled/common.h	2009-05-15 05:07:09 +0000
+++ drizzled/common.h	2009-06-08 16:51:22 +0000
@@ -64,7 +64,6 @@
 #define OPTION_BUFFER_RESULT    (UINT64_C(1) << 17)    // SELECT, user
 #define OPTION_NOT_AUTOCOMMIT   (UINT64_C(1) << 19)    // THD, user
 #define OPTION_BEGIN            (UINT64_C(1) << 20)    // THD, intern
-#define OPTION_TABLE_LOCK       (UINT64_C(1) << 21)    // THD, intern
 #define OPTION_QUICK            (UINT64_C(1) << 22)    // SELECT (for DELETE)
 #define OPTION_KEEP_LOG         (UINT64_C(1) << 23)    // THD, user
 

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2009-05-31 20:30:04 +0000
+++ drizzled/join.cc	2009-06-08 16:51:22 +0000
@@ -622,8 +622,7 @@
     error= -1;
     return(1);
   }
-  if (const_tables && !session->locked_tables &&
-      !(select_options & SELECT_NO_UNLOCK))
+  if (const_tables && !(select_options & SELECT_NO_UNLOCK))
     mysql_unlock_some_tables(session, table, const_tables);
   if (!conds && outer_join)
   {

=== modified file 'drizzled/lock.cc'
--- drizzled/lock.cc	2009-06-06 00:09:29 +0000
+++ drizzled/lock.cc	2009-06-09 01:58:43 +0000
@@ -273,7 +273,7 @@
     if (sql_lock)
     {
       mysql_unlock_tables(session,sql_lock);
-      sql_lock=0;
+      sql_lock= NULL;
     }
   }
 
@@ -536,7 +536,7 @@
 }
 
 
-DRIZZLE_LOCK *mysql_lock_merge(DRIZZLE_LOCK *a,DRIZZLE_LOCK *b)
+DRIZZLE_LOCK *mysql_lock_merge(DRIZZLE_LOCK *a, DRIZZLE_LOCK *b)
 {
   DRIZZLE_LOCK *sql_lock;
   Table **table, **end_table;
@@ -626,7 +626,7 @@
     goto end;
 
   /* Get command lock or LOCK TABLES lock. Maybe empty for INSERT DELAYED. */
-  if (! (mylock= session->lock ? session->lock : session->locked_tables))
+  if (!(mylock= session->lock))
     goto end;
 
   /* If we have less than two tables, we cannot have duplicates. */
@@ -881,7 +881,7 @@
   bool  found_locked_table= false;
   HASH_SEARCH_STATE state;
 
-  key_length= create_table_def_key(key, table_list);
+  key_length= table_list->create_table_def_key(key);
 
   if (check_in_use)
   {
@@ -908,18 +908,7 @@
     }
   }
 
-  if (session->locked_tables && session->locked_tables->table_count &&
-      ! find_temporary_table(session, table_list->db, table_list->table_name))
-  {
-    if (found_locked_table)
-      my_error(ER_TABLE_NOT_LOCKED_FOR_WRITE, MYF(0), table_list->alias);
-    else
-      my_error(ER_TABLE_NOT_LOCKED, MYF(0), table_list->alias);
-
-    return -1;
-  }
-
-  if (!(table= table_cache_insert_placeholder(session, key, key_length)))
+  if (!(table= session->table_cache_insert_placeholder(key, key_length)))
     return -1;
 
   table_list->table=table;
@@ -973,7 +962,7 @@
       result=1;
       break;
     }
-    wait_for_condition(session, &LOCK_open, &COND_refresh);
+    session->wait_for_condition(&LOCK_open, &COND_refresh);
     pthread_mutex_lock(&LOCK_open); /* Wait for a table to unlock and then lock it */
   }
   return result;
@@ -1061,69 +1050,6 @@
 
 
 /**
-  Test is 'table' is protected by an exclusive name lock.
-
-  @param[in] session        The current thread handler
-  @param[in] table_list Table container containing the single table to be
-                        tested
-
-  @note Needs to be protected by LOCK_open mutex.
-
-  @return Error status code
-    @retval TRUE Table is protected
-    @retval FALSE Table is not protected
-*/
-
-bool
-is_table_name_exclusively_locked_by_this_thread(Session *session,
-                                                TableList *table_list)
-{
-  char  key[MAX_DBKEY_LENGTH];
-  uint32_t  key_length;
-
-  key_length= create_table_def_key(key, table_list);
-
-  return is_table_name_exclusively_locked_by_this_thread(session, (unsigned char *)key,
-                                                         key_length);
-}
-
-
-/**
-  Test is 'table key' is protected by an exclusive name lock.
-
-  @param[in] session        The current thread handler.
-  @param[in] key
-  @param[in] key_length
-
-  @note Needs to be protected by LOCK_open mutex
-
-  @retval TRUE Table is protected
-  @retval FALSE Table is not protected
- */
-
-bool
-is_table_name_exclusively_locked_by_this_thread(Session *session, unsigned char *key,
-                                                int key_length)
-{
-  HASH_SEARCH_STATE state;
-  Table *table;
-
-  for (table= (Table*) hash_first(&open_cache, key,
-                                  key_length, &state);
-       table ;
-       table= (Table*) hash_next(&open_cache, key,
-                                 key_length, &state))
-  {
-    if (table->in_use == session &&
-        table->open_placeholder == 1 &&
-        table->s->version == 0)
-      return true;
-  }
-
-  return false;
-}
-
-/**
   Unlock all tables in list with a name lock.
 
   @param

=== modified file 'drizzled/lock.h'
--- drizzled/lock.h	2009-06-06 00:09:29 +0000
+++ drizzled/lock.h	2009-06-09 01:58:43 +0000
@@ -63,10 +63,5 @@
 bool lock_table_names(Session *session, TableList *table_list);
 void unlock_table_names(TableList *table_list, TableList *last_table);
 bool lock_table_names_exclusively(Session *session, TableList *table_list);
-bool is_table_name_exclusively_locked_by_this_thread(Session *session,
-                                                     TableList *table_list);
-bool is_table_name_exclusively_locked_by_this_thread(Session *session,
-                                                     unsigned char *key,
-                                                     int key_length);
 
 #endif /* DRIZZLED_LOCK_H */

=== modified file 'drizzled/open_tables_state.h'
--- drizzled/open_tables_state.h	2009-06-03 19:29:56 +0000
+++ drizzled/open_tables_state.h	2009-06-08 16:51:22 +0000
@@ -60,13 +60,6 @@
     See also lock_tables() for details.
   */
   DRIZZLE_LOCK *lock;
-  /*
-    Tables that were locked with explicit or implicit LOCK TABLES.
-    (Implicit LOCK TABLES happens when we are prelocking tables for
-     execution of statement which uses stored routines. See description
-     Session::prelocked_mode for more info.)
-  */
-  DRIZZLE_LOCK *locked_tables;
 
   /*
     CREATE-SELECT keeps an extra lock for the table being
@@ -103,7 +96,7 @@
   void reset_open_tables_state()
   {
     open_tables= temporary_tables= derived_tables= NULL;
-    extra_lock= lock= locked_tables= NULL;
+    extra_lock= lock= NULL;
     state_flags= 0U;
   }
 };

=== modified file 'drizzled/rename.cc'
--- drizzled/rename.cc	2009-06-02 09:09:44 +0000
+++ drizzled/rename.cc	2009-06-08 16:51:22 +0000
@@ -40,14 +40,14 @@
     Avoid problems with a rename on a table that we have locked or
     if the user is trying to to do this in a transcation context
   */
-  if (session->locked_tables || session->inTransaction())
+  if (session->inTransaction())
   {
     my_message(ER_LOCK_OR_ACTIVE_TRANSACTION, ER(ER_LOCK_OR_ACTIVE_TRANSACTION), MYF(0));
-    return(1);
+    return true;
   }
 
   if (wait_if_global_read_lock(session,0,1))
-    return(1);
+    return true;
 
   pthread_mutex_lock(&LOCK_open); /* Rename table lock for exclusive access */
   if (lock_table_names_exclusively(session, table_list))
@@ -100,6 +100,7 @@
 
 err:
   start_waiting_global_read_lock(session);
+
   return error;
 }
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2009-06-08 01:32:13 +0000
+++ drizzled/session.cc	2009-06-08 22:21:27 +0000
@@ -389,11 +389,6 @@
     ha_rollback(this);
     xid_cache_delete(&transaction.xid_state);
   }
-  if (locked_tables)
-  {
-    lock=locked_tables; locked_tables=0;
-    close_thread_tables();
-  }
   hash_free(&user_vars);
   close_temporary_tables();
 
@@ -790,11 +785,8 @@
     my_error(ER_XAER_RMFAIL, MYF(0), xa_state_names[transaction.xid_state.xa_state]);
     return false;
   }
-  if (options & (OPTION_NOT_AUTOCOMMIT | OPTION_BEGIN | OPTION_TABLE_LOCK))
+  if (options & (OPTION_NOT_AUTOCOMMIT | OPTION_BEGIN))
   {
-    /* Safety if one did "drop table" on locked tables */
-    if (! locked_tables)
-      options&= ~OPTION_TABLE_LOCK;
     server_status&= ~SERVER_STATUS_IN_TRANS;
     if (ha_commit(this))
       result= false;
@@ -808,12 +800,6 @@
 {
   bool result= true;
 
-  if (locked_tables)
-  {
-    lock= locked_tables;
-    locked_tables= 0;			// Will be automatically closed
-    close_thread_tables();			// Free tables
-  }
   if (! endActiveTransaction())
     result= false;
   else
@@ -1818,7 +1804,7 @@
   */
   assert(open_tables == 0 && temporary_tables == 0 &&
               derived_tables == 0 &&
-              lock == 0 && locked_tables == 0);
+              lock == 0);
   set_open_tables_state(backup);
 }
 
@@ -2019,7 +2005,7 @@
   for (table= temporary_tables; table; table= tmp_next)
   {
     tmp_next= table->next;
-    close_temporary(table, 1, 1);
+    close_temporary(table, true, true);
   }
   temporary_tables= NULL;
 }
@@ -2225,18 +2211,6 @@
     transaction.stmt.reset();
   }
 
-  if (locked_tables)
-  {
-
-    /* Ensure we are calling ha_reset() for all used tables */
-    mark_used_tables_as_free_for_reuse(open_tables);
-
-    /*
-      We are under simple LOCK TABLES so should not do anything else.
-    */
-    return;
-  }
-
   if (lock)
   {
     /*
@@ -2261,3 +2235,109 @@
   if (open_tables)
     close_open_tables();
 }
+
+
+/*
+  Prepare statement for reopening of tables and recalculation of set of
+  prelocked tables.
+
+  SYNOPSIS
+  close_tables_for_reopen()
+  session    in     Thread context
+  tables in/out List of tables which we were trying to open and lock
+
+*/
+
+void Session::close_tables_for_reopen(TableList **tables)
+{
+  /*
+    If table list consists only from tables from prelocking set, table list
+    for new attempt should be empty, so we have to update list's root pointer.
+  */
+  if (lex->first_not_own_table() == *tables)
+    *tables= 0;
+  lex->chop_off_not_own_tables();
+  for (TableList *tmp= *tables; tmp; tmp= tmp->next_global)
+    tmp->table= 0;
+  close_thread_tables();
+}
+
+
+/*
+  Open all tables in list, locks them (all, including derived)
+
+  SYNOPSIS
+  open_and_lock_tables_derived()
+  session		- thread handler
+  tables	- list of tables for open&locking
+  derived     - if to handle derived tables
+
+  RETURN
+  false - ok
+  true  - error
+
+  NOTE
+  The lock will automaticaly be freed by close_thread_tables()
+
+  NOTE
+  There are two convenience functions:
+  - simple_open_n_lock_tables(session, tables)  without derived handling
+  - open_and_lock_tables(session, tables)       with derived handling
+  Both inline functions call open_and_lock_tables_derived() with
+  the third argument set appropriately.
+*/
+
+int Session::open_and_lock_tables(TableList *tables)
+{
+  uint32_t counter;
+  bool need_reopen;
+
+  for ( ; ; )
+  {
+    if (open_tables_from_list(&tables, &counter, 0))
+      return -1;
+
+    if (!lock_tables(this, tables, counter, &need_reopen))
+      break;
+    if (!need_reopen)
+      return -1;
+    close_tables_for_reopen(&tables);
+  }
+  if ((mysql_handle_derived(lex, &mysql_derived_prepare) ||
+       (fill_derived_tables() &&
+        mysql_handle_derived(lex, &mysql_derived_filling))))
+    return 1; /* purecov: inspected */
+
+  return 0;
+}
+
+
+/*
+  Open all tables in list and process derived tables
+
+  SYNOPSIS
+  open_normal_and_derived_tables
+  session		- thread handler
+  tables	- list of tables for open
+  flags       - bitmap of flags to modify how the tables will be open:
+  DRIZZLE_LOCK_IGNORE_FLUSH - open table even if someone has
+  done a flush or namelock on it.
+
+  RETURN
+  false - ok
+  true  - error
+
+  NOTE
+  This is to be used on prepare stage when you don't read any
+  data from the tables.
+*/
+
+bool Session::open_normal_and_derived_tables(TableList *tables, uint32_t flags)
+{
+  uint32_t counter;
+  assert(!(fill_derived_tables()));
+  if (open_tables_from_list(&tables, &counter, flags) ||
+      mysql_handle_derived(lex, &mysql_derived_prepare))
+    return true; /* purecov: inspected */
+  return false;
+}

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2009-06-08 01:32:13 +0000
+++ drizzled/session.h	2009-06-09 01:58:43 +0000
@@ -1242,10 +1242,37 @@
   void close_thread_tables();
   void close_old_data_files(bool morph_locks, bool send_refresh);
   void close_open_tables();
+  void close_data_files_and_morph_locks(const char *db, const char *table_name);
+  void close_tables_for_reopen(TableList **tables);
+
+  /* open_and_lock_tables with derived handling */
+  int open_and_lock_tables(TableList *tables);
+  bool open_normal_and_derived_tables(TableList *tables, uint32_t flags);
+  int open_tables_from_list(TableList **start, uint32_t *counter, uint32_t flags);
+  Table *open_ltable(TableList *table_list, thr_lock_type lock_type);
+  Table *open_table(TableList *table_list, bool *refresh, uint32_t flags);
+  void unlink_open_table(Table *find);
+  void drop_open_table(Table *table, const char *db_name,
+                       const char *table_name);
+  void close_cached_table(Table *table);
+
+  /* Create a lock in the cache */
+  Table *table_cache_insert_placeholder(const char *key, uint32_t key_length);
+  bool lock_table_name_if_not_cached(const char *db, 
+                                     const char *table_name, Table **table);
+
+  /* Work with temporary tables */
+  Table *find_temporary_table(TableList *table_list);
+  Table *find_temporary_table(const char *db, const char *table_name);
   void close_temporary_tables();
-  void close_data_files_and_morph_locks(const char *db, const char *table_name);
+  void close_temporary_table(Table *table, bool free_share, bool delete_table);
+  int drop_temporary_table(TableList *table_list);
+  
+  /* Reopen operations */
   bool reopen_tables(bool get_locks, bool mark_share_as_old);
-  void close_tables_for_reopen(TableList **tables);
+  bool reopen_name_locked_table(TableList* table_list, bool link_in);
+
+  void wait_for_condition(pthread_mutex_t *mutex, pthread_cond_t *cond);
 };
 
 /*

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-06-05 02:29:41 +0000
+++ drizzled/show.cc	2009-06-08 22:21:27 +0000
@@ -347,7 +347,7 @@
   String buffer(buff, sizeof(buff), system_charset_info);
 
   /* Only one table for now, but VIEW can involve several tables */
-  if (open_normal_and_derived_tables(session, table_list, 0))
+  if (session->open_normal_and_derived_tables(table_list, 0))
   {
     if (session->is_error())
       return true;
@@ -444,7 +444,7 @@
 {
   Table *table;
 
-  if (open_normal_and_derived_tables(session, table_list, 0))
+  if (session->open_normal_and_derived_tables(table_list, 0))
     return;
   table= table_list->table;
 
@@ -2158,8 +2158,7 @@
     SQLCOM_SHOW_FIELDS is used because it satisfies 'only_view_structure()'
   */
   lex->sql_command= SQLCOM_SHOW_FIELDS;
-  res= open_normal_and_derived_tables(session, show_table_list,
-                                      DRIZZLE_LOCK_IGNORE_FLUSH);
+  res= session->open_normal_and_derived_tables(show_table_list, DRIZZLE_LOCK_IGNORE_FLUSH);
   lex->sql_command= save_sql_command;
   /*
     get_all_tables() returns 1 on failure and 0 on success thus
@@ -2309,7 +2308,7 @@
   table_list.table_name= table_name->str;
   table_list.db= db_name->str;
 
-  key_length= create_table_def_key(key, &table_list);
+  key_length= table_list.create_table_def_key(key);
   pthread_mutex_lock(&LOCK_open); /* Locking to get table share when filling schema table from FRM */
   share= get_table_share(session, &table_list, key,
                          key_length, 0, &error);
@@ -2517,16 +2516,15 @@
             lex->sql_command= SQLCOM_SHOW_FIELDS;
             show_table_list->i_s_requested_object=
               schema_table->i_s_requested_object;
-            res= open_normal_and_derived_tables(session, show_table_list,
-                                                DRIZZLE_LOCK_IGNORE_FLUSH);
+            res= session->open_normal_and_derived_tables(show_table_list, DRIZZLE_LOCK_IGNORE_FLUSH);
             lex->sql_command= save_sql_command;
             /*
-XXX:  show_table_list has a flag i_is_requested,
-and when it's set, open_normal_and_derived_tables()
-can return an error without setting an error message
-in Session, which is a hack. This is why we have to
-check for res, then for session->is_error() only then
-for session->main_da.sql_errno().
+              XXX->  show_table_list has a flag i_is_requested,
+              and when it's set, open_normal_and_derived_tables()
+              can return an error without setting an error message
+              in Session, which is a hack. This is why we have to
+              check for res, then for session->is_error() only then
+              for session->main_da.sql_errno().
             */
             if (res && session->is_error() &&
                 session->main_da.sql_errno() == ER_NO_SUCH_TABLE)

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-06-08 01:32:13 +0000
+++ drizzled/sql_base.cc	2009-06-09 01:58:43 +0000
@@ -96,41 +96,6 @@
   return open_cache.records;
 }
 
-/*
-  Create a table cache key
-
-  SYNOPSIS
-  create_table_def_key()
-  key			Create key here (must be of size MAX_DBKEY_LENGTH)
-  table_list		Table definition
-
-  IMPLEMENTATION
-  The table cache_key is created from:
-  db_name + \0
-  table_name + \0
-
-  if the table is a tmp table, we add the following to make each tmp table
-  unique on the slave:
-
-  4 bytes for master thread id
-  4 bytes pseudo thread id
-
-  RETURN
-  Length of key
-*/
-
-uint32_t create_table_def_key(char *key, TableList *table_list)
-{
-  uint32_t key_length;
-  char *key_pos= key;
-  key_pos= strcpy(key_pos, table_list->db) + strlen(table_list->db);
-  key_pos= strcpy(key_pos+1, table_list->table_name) +
-    strlen(table_list->table_name);
-  key_length= (uint32_t)(key_pos-key)+1;
-
-  return key_length;
-}
-
 
 
 /*****************************************************************************
@@ -362,7 +327,7 @@
 
   table_list.db= (char*) db;
   table_list.table_name= (char*) table_name;
-  key_length= create_table_def_key(key, &table_list);
+  key_length= table_list.create_table_def_key(key);
   return (TableShare*) hash_search(&table_def_cache,(unsigned char*) key, key_length);
 }
 
@@ -926,52 +891,31 @@
 }
 
 
-/*
-  Issue correct error message in case we found 2 duplicate tables which
-  prevent some update operation
-
-  SYNOPSIS
-  update_non_unique_table_error()
-  update      table which we try to update
-  operation   name of update operation
-  duplicate   duplicate table which we found
-
-NOTE:
-here we hide view underlying tables if we have them
-*/
-
-void update_non_unique_table_error(TableList *update,
-                                   const char *,
-                                   TableList *)
-{
-  my_error(ER_UPDATE_TABLE_USED, MYF(0), update->alias);
-}
-
-
-Table *find_temporary_table(Session *session, const char *db, const char *table_name)
+Table *Session::find_temporary_table(const char *new_db, const char *table_name)
 {
   TableList table_list;
 
-  table_list.db= (char*) db;
+  table_list.db= (char*) new_db;
   table_list.table_name= (char*) table_name;
-  return find_temporary_table(session, &table_list);
+
+  return find_temporary_table(&table_list);
 }
 
 
-Table *find_temporary_table(Session *session, TableList *table_list)
+Table *Session::find_temporary_table(TableList *table_list)
 {
   char	key[MAX_DBKEY_LENGTH];
   uint	key_length;
   Table *table;
 
-  key_length= create_table_def_key(key, table_list);
-  for (table=session->temporary_tables ; table ; table= table->next)
+  key_length= table_list->create_table_def_key(key);
+  for (table= temporary_tables ; table ; table= table->next)
   {
     if (table->s->table_cache_key.length == key_length &&
         !memcmp(table->s->table_cache_key.str, key, key_length))
-      return(table);
+      return table;
   }
-  return 0;                               // Not a temporary table
+  return NULL;                               // Not a temporary table
 }
 
 
@@ -1001,26 +945,21 @@
   @retval -1  the table is in use by a outer query
 */
 
-int drop_temporary_table(Session *session, TableList *table_list)
+int Session::drop_temporary_table(TableList *table_list)
 {
   Table *table;
 
-  if (!(table= find_temporary_table(session, table_list)))
+  if (!(table= find_temporary_table(table_list)))
     return 1;
 
   /* Table might be in use by some outer statement. */
-  if (table->query_id && table->query_id != session->query_id)
+  if (table->query_id && table->query_id != query_id)
   {
     my_error(ER_CANT_REOPEN_TABLE, MYF(0), table->alias);
     return -1;
   }
 
-  /*
-    If LOCK TABLES list is not empty and contains this table,
-    unlock the table and remove the table from this list.
-  */
-  mysql_lock_remove(session, session->locked_tables, table, false);
-  close_temporary_table(session, table, 1, 1);
+  close_temporary_table(table, true, true);
 
   return 0;
 }
@@ -1029,8 +968,8 @@
   unlink from session->temporary tables and close temporary table
 */
 
-void close_temporary_table(Session *session, Table *table,
-                           bool free_share, bool delete_table)
+void Session::close_temporary_table(Table *table,
+                                    bool free_share, bool delete_table)
 {
   if (table->prev)
   {
@@ -1041,15 +980,15 @@
   else
   {
     /* removing the item from the list */
-    assert(table == session->temporary_tables);
+    assert(table == temporary_tables);
     /*
       slave must reset its temporary list pointer to zero to exclude
       passing non-zero value to end_slave via rli->save_temporary_tables
       when no temp tables opened, see an invariant below.
     */
-    session->temporary_tables= table->next;
-    if (session->temporary_tables)
-      table->next->prev= 0;
+    temporary_tables= table->next;
+    if (temporary_tables)
+      table->next->prev= NULL;
   }
   close_temporary(table, free_share, delete_table);
 }
@@ -1076,7 +1015,7 @@
   if (free_share)
   {
     table->s->free_table_share();
-    free((char*) table);
+    delete table;
   }
 }
 
@@ -1101,7 +1040,7 @@
 
   table_list.db= (char*) db;
   table_list.table_name= (char*) table_name;
-  key_length= create_table_def_key(key, &table_list);
+  key_length= table_list.create_table_def_key(key);
   share->set_table_cache_key(key, key_length);
 
   return false;
@@ -1131,16 +1070,9 @@
 
   @param  session     Thread context
   @param  find    Table to remove
-  @param  unlock  true  - free all locks on tables removed that are
-  done with LOCK TABLES
-  false - otherwise
-
-  @note When unlock parameter is false or current thread doesn't have
-  any tables locked with LOCK TABLES, tables are assumed to be
-  not locked (for example already unlocked).
 */
 
-void unlink_open_table(Session *session, Table *find, bool unlock)
+void Session::unlink_open_table(Table *find)
 {
   char key[MAX_DBKEY_LENGTH];
   uint32_t key_length= find->s->table_cache_key.length;
@@ -1156,16 +1088,13 @@
     Closing a MERGE child before the parent would be fatal if the
     other thread tries to abort the MERGE lock in between.
   */
-  for (prev= &session->open_tables; *prev; )
+  for (prev= &open_tables; *prev; )
   {
     list= *prev;
 
     if (list->s->table_cache_key.length == key_length &&
         !memcmp(list->s->table_cache_key.str, key, key_length))
     {
-      if (unlock && session->locked_tables)
-        mysql_lock_remove(session, session->locked_tables, list, true);
-
       /* Remove table from open_tables list. */
       *prev= list->next;
       /* Close table. */
@@ -1202,11 +1131,11 @@
   table that was locked with LOCK TABLES.
 */
 
-void drop_open_table(Session *session, Table *table, const char *db_name,
-                     const char *table_name)
+void Session::drop_open_table(Table *table, const char *db_name,
+                              const char *table_name)
 {
   if (table->s->tmp_table)
-    close_temporary_table(session, table, 1, 1);
+    close_temporary_table(table, true, true);
   else
   {
     StorageEngine *table_type= table->s->db_type();
@@ -1215,7 +1144,7 @@
       unlink_open_table() also tells threads waiting for refresh or close
       that something has happened.
     */
-    unlink_open_table(session, table, false);
+    unlink_open_table(table);
     quick_rm_table(table_type, db_name, table_name, false);
     pthread_mutex_unlock(&LOCK_open);
   }
@@ -1233,15 +1162,15 @@
   cond	Condition to wait for
 */
 
-void wait_for_condition(Session *session, pthread_mutex_t *mutex, pthread_cond_t *cond)
+void Session::wait_for_condition(pthread_mutex_t *mutex, pthread_cond_t *cond)
 {
   /* Wait until the current table is up to date */
-  const char *proc_info;
-  session->mysys_var->current_mutex= mutex;
-  session->mysys_var->current_cond= cond;
-  proc_info=session->get_proc_info();
-  session->set_proc_info("Waiting for table");
-  if (!session->killed)
+  const char *saved_proc_info;
+  mysys_var->current_mutex= mutex;
+  mysys_var->current_cond= cond;
+  saved_proc_info= get_proc_info();
+  set_proc_info("Waiting for table");
+  if (!killed)
     (void) pthread_cond_wait(cond, mutex);
 
   /*
@@ -1256,11 +1185,11 @@
   */
 
   pthread_mutex_unlock(mutex);
-  pthread_mutex_lock(&session->mysys_var->mutex);
-  session->mysys_var->current_mutex= 0;
-  session->mysys_var->current_cond= 0;
-  session->set_proc_info(proc_info);
-  pthread_mutex_unlock(&session->mysys_var->mutex);
+  pthread_mutex_lock(&mysys_var->mutex);
+  mysys_var->current_mutex= 0;
+  mysys_var->current_cond= 0;
+  set_proc_info(saved_proc_info);
+  pthread_mutex_unlock(&mysys_var->mutex);
 }
 
 
@@ -1320,7 +1249,7 @@
   true  - Error
 */
 
-bool reopen_name_locked_table(Session* session, TableList* table_list, bool link_in)
+bool Session::reopen_name_locked_table(TableList* table_list, bool link_in)
 {
   Table *table= table_list->table;
   TableShare *share;
@@ -1329,12 +1258,12 @@
 
   safe_mutex_assert_owner(&LOCK_open);
 
-  if (session->killed || !table)
+  if (killed || !table)
     return true;
 
   orig_table= *table;
 
-  if (open_unireg_entry(session, table, table_list, table_name,
+  if (open_unireg_entry(this, table, table_list, table_name,
                         table->s->table_cache_key.str,
                         table->s->table_cache_key.length))
   {
@@ -1359,12 +1288,12 @@
     before we will get table-level lock on this table.
   */
   share->version=0;
-  table->in_use = session;
+  table->in_use = this;
 
   if (link_in)
   {
-    table->next= session->open_tables;
-    session->open_tables= table;
+    table->next= open_tables;
+    open_tables= table;
   }
   else
   {
@@ -1375,13 +1304,13 @@
     table->next= orig_table.next;
   }
 
-  table->tablenr=session->current_tablenr++;
-  table->used_fields=0;
-  table->const_table=0;
+  table->tablenr= current_tablenr++;
+  table->used_fields= 0;
+  table->const_table= 0;
   table->null_row= false;
   table->maybe_null= false;
   table->force_index= false;
-  table->status=STATUS_NO_RECORD;
+  table->status= STATUS_NO_RECORD;
 
   return false;
 }
@@ -1400,8 +1329,7 @@
   case of failure.
 */
 
-Table *table_cache_insert_placeholder(Session *session, const char *key,
-                                      uint32_t key_length)
+Table *Session::table_cache_insert_placeholder(const char *key, uint32_t key_length)
 {
   Table *table;
   TableShare *share;
@@ -1424,7 +1352,7 @@
   table->s= share;
   share->set_table_cache_key(key_buff, key, key_length);
   share->tmp_table= INTERNAL_TMP_TABLE;  // for intern_close_table
-  table->in_use= session;
+  table->in_use= this;
   table->locked_by_name=1;
 
   if (my_hash_insert(&open_cache, (unsigned char*)table))
@@ -1459,14 +1387,14 @@
   @retval  false  Success. 'table' parameter set according to above rules.
 */
 
-bool lock_table_name_if_not_cached(Session *session, const char *db,
-                                   const char *table_name, Table **table)
+bool Session::lock_table_name_if_not_cached(const char *new_db,
+                                            const char *table_name, Table **table)
 {
   char key[MAX_DBKEY_LENGTH];
   char *key_pos= key;
   uint32_t key_length;
 
-  key_pos= strcpy(key_pos, db) + strlen(db);
+  key_pos= strcpy(key_pos, new_db) + strlen(new_db);
   key_pos= strcpy(key_pos+1, table_name) + strlen(table_name);
   key_length= (uint32_t) (key_pos-key)+1;
 
@@ -1478,15 +1406,16 @@
     *table= 0;
     return false;
   }
-  if (!(*table= table_cache_insert_placeholder(session, key, key_length)))
+  if (!(*table= table_cache_insert_placeholder(key, key_length)))
   {
     pthread_mutex_unlock(&LOCK_open);
     return true;
   }
   (*table)->open_placeholder= true;
-  (*table)->next= session->open_tables;
-  session->open_tables= *table;
+  (*table)->next= open_tables;
+  open_tables= *table;
   pthread_mutex_unlock(&LOCK_open);
+
   return false;
 }
 
@@ -1523,7 +1452,7 @@
 */
 
 
-Table *open_table(Session *session, TableList *table_list, bool *refresh, uint32_t flags)
+Table *Session::open_table(TableList *table_list, bool *refresh, uint32_t flags)
 {
   register Table *table;
   char key[MAX_DBKEY_LENGTH];
@@ -1532,20 +1461,20 @@
   HASH_SEARCH_STATE state;
 
   /* Parsing of partitioning information from .frm needs session->lex set up. */
-  assert(session->lex->is_lex_started);
+  assert(lex->is_lex_started);
 
   /* find a unused table in the open table cache */
   if (refresh)
     *refresh= false;
 
   /* an open table operation needs a lot of the stack space */
-  if (check_stack_overrun(session, STACK_MIN_SIZE_FOR_OPEN, (unsigned char *)&alias))
-    return NULL;
-
-  if (session->killed)
-    return NULL;
-
-  key_length= create_table_def_key(key, table_list);
+  if (check_stack_overrun(this, STACK_MIN_SIZE_FOR_OPEN, (unsigned char *)&alias))
+    return NULL;
+
+  if (killed)
+    return NULL;
+
+  key_length= table_list->create_table_def_key(key);
 
   /*
     Unless requested otherwise, try to resolve this table in the list
@@ -1554,7 +1483,7 @@
     same name. This block implements the behaviour.
     TODO -> move this block into a separate function.
   */
-  for (table= session->temporary_tables; table ; table=table->next)
+  for (table= temporary_tables; table ; table=table->next)
   {
     if (table->s->table_cache_key.length == key_length && !memcmp(table->s->table_cache_key.str, key, key_length))
     {
@@ -1569,7 +1498,7 @@
         my_error(ER_CANT_REOPEN_TABLE, MYF(0), table->alias);
         return NULL;
       }
-      table->query_id= session->query_id;
+      table->query_id= query_id;
       goto reset;
     }
   }
@@ -1581,92 +1510,6 @@
   }
 
   /*
-    The table is not temporary - if we're in pre-locked or LOCK TABLES
-    mode, let's try to find the requested table in the list of pre-opened
-    and locked tables. If the table is not there, return an error - we can't
-    open not pre-opened tables in pre-locked/LOCK TABLES mode.
-TODO: move this block into a separate function.
-  */
-  if (session->locked_tables)
-  { // Using table locks
-    Table *best_table= 0;
-    int best_distance= INT_MIN;
-    bool check_if_used= false;
-    for (table=session->open_tables; table ; table=table->next)
-    {
-      if (table->s->table_cache_key.length == key_length &&
-          !memcmp(table->s->table_cache_key.str, key, key_length))
-      {
-        if (check_if_used && table->query_id &&
-            table->query_id != session->query_id)
-        {
-          /*
-            If we are in stored function or trigger we should ensure that
-            we won't change table that is already used by calling statement.
-            So if we are opening table for writing, we should check that it
-            is not already open by some calling stamement.
-          */
-          my_error(ER_CANT_UPDATE_USED_TABLE_IN_SF_OR_TRG, MYF(0),
-                   table->s->table_name.str);
-          return NULL;
-        }
-        /*
-          When looking for a usable Table, ignore MERGE children, as they
-          belong to their parent and cannot be used explicitly.
-        */
-        if (!my_strcasecmp(system_charset_info, table->alias, alias) &&
-            table->query_id != session->query_id)  /* skip tables already used */
-        {
-          int distance= ((int) table->reginfo.lock_type -
-                         (int) table_list->lock_type);
-          /*
-            Find a table that either has the exact lock type requested,
-            or has the best suitable lock. In case there is no locked
-            table that has an equal or higher lock than requested,
-            we us the closest matching lock to be able to produce an error
-            message about wrong lock mode on the table. The best_table
-            is changed if bd < 0 <= d or bd < d < 0 or 0 <= d < bd.
-
-            distance <  0 - No suitable lock found
-            distance >  0 - we have lock mode higher then we require
-            distance == 0 - we have lock mode exactly which we need
-          */
-          if ((best_distance < 0 && distance > best_distance) || (distance >= 0 && distance < best_distance))
-          {
-            best_distance= distance;
-            best_table= table;
-            if (best_distance == 0 && !check_if_used)
-            {
-              /*
-                If we have found perfect match and we don't need to check that
-                table is not used by one of calling statements (assuming that
-                we are inside of function or trigger) we can finish iterating
-                through open tables list.
-              */
-              break;
-            }
-          }
-        }
-      }
-    }
-    if (best_table)
-    {
-      table= best_table;
-      table->query_id= session->query_id;
-      goto reset;
-    }
-    /*
-      No table in the locked tables list. In case of explicit LOCK TABLES
-      this can happen if a user did not include the able into the list.
-      In case of pre-locked mode locked tables list is generated automatically,
-      so we may only end up here if the table did not exist when
-      locked tables list was created.
-    */
-    my_error(ER_TABLE_NOT_LOCKED, MYF(0), alias);
-    return NULL;
-  }
-
-  /*
     If it's the first table from a list of tables used in a query,
     remember refresh_version (the version of open_cache state).
     If the version changes while we're opening the remaining tables,
@@ -1675,9 +1518,9 @@
 
     Note-> refresh_version is currently changed only during FLUSH TABLES.
   */
-  if (!session->open_tables)
-    session->version=refresh_version;
-  else if ((session->version != refresh_version) &&
+  if (!open_tables)
+    version= refresh_version;
+  else if ((version != refresh_version) &&
            ! (flags & DRIZZLE_LOCK_IGNORE_FLUSH))
   {
     /* Someone did a refresh while thread was opening tables */
@@ -1690,7 +1533,7 @@
   /*
     Before we test the global cache, we test our local session cache.
   */
-  if (session->cached_table)
+  if (cached_table)
   {
     assert(false); /* Not implemented yet */
   }
@@ -1751,12 +1594,12 @@
       if (flags & DRIZZLE_LOCK_IGNORE_FLUSH)
       {
         /* Force close at once after usage */
-        session->version= table->s->version;
+        version= table->s->version;
         continue;
       }
 
       /* Avoid self-deadlocks by detecting self-dependencies. */
-      if (table->open_placeholder && table->in_use == session)
+      if (table->open_placeholder && table->in_use == this)
       {
         pthread_mutex_unlock(&LOCK_open);
         my_error(ER_UPDATE_TABLE_USED, MYF(0), table->s->table_name.str);
@@ -1772,7 +1615,7 @@
         that the tables in question are not used any more. See
         table_is_used call for details.
       */
-      session->close_old_data_files(false, false);
+      close_old_data_files(false, false);
 
       /*
         Back-off part 2: try to avoid "busy waiting" on the table:
@@ -1789,10 +1632,10 @@
         after we open first instance but before we open second
         instance.
       */
-      if (table->in_use != session)
+      if (table->in_use != this)
       {
         /* wait_for_conditionwill unlock LOCK_open for us */
-        wait_for_condition(session, &LOCK_open, &COND_refresh);
+        wait_for_condition(&LOCK_open, &COND_refresh);
       }
       else
       {
@@ -1818,7 +1661,7 @@
     }
     table->prev->next=table->next; /* Remove from unused list */
     table->next->prev=table->prev;
-    table->in_use= session;
+    table->in_use= this;
   }
   else
   {
@@ -1830,14 +1673,14 @@
 
     if (table_list->create)
     {
-      if (ha_table_exists_in_engine(session, table_list->db,
+      if (ha_table_exists_in_engine(this, table_list->db,
                                     table_list->table_name)
           != HA_ERR_TABLE_EXIST)
       {
         /*
           Table to be created, so we need to create placeholder in table-cache.
         */
-        if (!(table= table_cache_insert_placeholder(session, key, key_length)))
+        if (!(table= table_cache_insert_placeholder(key, key_length)))
         {
           pthread_mutex_unlock(&LOCK_open);
           return NULL;
@@ -1848,9 +1691,10 @@
           by other trying to take name-lock.
         */
         table->open_placeholder= true;
-        table->next= session->open_tables;
-        session->open_tables= table;
+        table->next= open_tables;
+        open_tables= table;
         pthread_mutex_unlock(&LOCK_open);
+
         return table ;
       }
       /* Table exists. Let us try to open it. */
@@ -1864,7 +1708,7 @@
       return NULL;
     }
 
-    error= open_unireg_entry(session, table, table_list, alias, key, key_length);
+    error= open_unireg_entry(this, table, table_list, alias, key, key_length);
     if (error != 0)
     {
       free(table);
@@ -1877,15 +1721,15 @@
   pthread_mutex_unlock(&LOCK_open);
   if (refresh)
   {
-    table->next=session->open_tables; /* Link into simple list */
-    session->open_tables=table;
+    table->next= open_tables; /* Link into simple list */
+    open_tables=table;
   }
   table->reginfo.lock_type= TL_READ; /* Assume read */
 
 reset:
   assert(table->s->ref_count > 0 || table->s->tmp_table != NO_TMP_TABLE);
 
-  if (session->lex->need_correct_ident())
+  if (lex->need_correct_ident())
     table->alias_name_used= my_strcasecmp(table_alias_charset,
                                           table->s->table_name.str, alias);
   /* Fix alias if table name changes */
@@ -1897,7 +1741,7 @@
   }
 
   /* These variables are also set in reopen_table() */
-  table->tablenr=session->current_tablenr++;
+  table->tablenr= current_tablenr++;
   table->used_fields= 0;
   table->const_table= 0;
   table->null_row= false;
@@ -2070,10 +1914,6 @@
     if (!strcmp(table->s->table_name.str, new_table_name) &&
         !strcmp(table->s->db.str, new_db))
     {
-      if (locked_tables)
-      {
-        mysql_lock_remove(this, locked_tables, table, true);
-      }
       table->open_placeholder= true;
       close_handle_and_leave_table_as_lock(table);
     }
@@ -2169,7 +2009,7 @@
     if ((local_lock= mysql_lock_tables(this, tables, (uint32_t) (tables_ptr - tables),
                                  flags, &not_used)))
     {
-      locked_tables=mysql_lock_merge(locked_tables, local_lock);
+      /* unused */
     }
     else
     {
@@ -2234,7 +2074,7 @@
               instances of this table.
             */
             mysql_lock_abort(this, ulcktbl, true);
-            mysql_lock_remove(this, locked_tables, ulcktbl, true);
+            mysql_lock_remove(this, NULL, ulcktbl, true);
             ulcktbl->lock_count= 0;
           }
           if ((ulcktbl != table) && ulcktbl->db_stat)
@@ -2390,7 +2230,7 @@
     if (!strcmp(table->s->table_name.str, table_name) &&
         !strcmp(table->s->db.str, db))
     {
-      mysql_lock_remove(session, session->locked_tables, table, true);
+      mysql_lock_remove(session, NULL, table, true);
 
       if (!found)
       {
@@ -2417,11 +2257,7 @@
   *prev=0;
   if (found)
     broadcast_refresh();
-  if (session->locked_tables && session->locked_tables->table_count == 0)
-  {
-    free((unsigned char*) session->locked_tables);
-    session->locked_tables=0;
-  }
+
   return(found);
 }
 
@@ -2499,17 +2335,17 @@
         goto err;
 
       /*
-TODO:
-Here we should wait until all threads has released the table.
-For now we do one retry. This may cause a deadlock if there
-is other threads waiting for other tables used by this thread.
+        TODO->
+        Here we should wait until all threads has released the table.
+        For now we do one retry. This may cause a deadlock if there
+        is other threads waiting for other tables used by this thread.
 
-Proper fix would be to if the second retry failed:
-- Mark that table def changed
-- Return from open table
-- Close all tables used by this thread
-- Start waiting that the share is released
-- Retry by opening all tables again
+        Proper fix would be to if the second retry failed:
+        - Mark that table def changed
+        - Return from open table
+        - Close all tables used by this thread
+        - Start waiting that the share is released
+        - Retry by opening all tables again
       */
 
       /*
@@ -2645,25 +2481,18 @@
   -1 - error
 */
 
-int open_tables(Session *session, TableList **start, uint32_t *counter, uint32_t flags)
+int Session::open_tables_from_list(TableList **start, uint32_t *counter, uint32_t flags)
 {
   TableList *tables= NULL;
   bool refresh;
-  int result=0;
-  MEM_ROOT new_frm_mem;
+  int result= 0;
   /* Also used for indicating that prelocking is need */
   bool safe_to_ignore_table;
 
-  /*
-    temporary mem_root for new .frm parsing.
-TODO: variables for size
-  */
-  init_sql_alloc(&new_frm_mem, 8024, 8024);
-
-  session->current_tablenr= 0;
+  current_tablenr= 0;
 restart:
   *counter= 0;
-  session->set_proc_info("Opening tables");
+  set_proc_info("Opening tables");
 
   /*
     For every table in the list of tables to open, try to find or open
@@ -2691,7 +2520,7 @@
     */
     if (tables->schema_table)
     {
-      if (mysql_schema_table(session, session->lex, tables) == false)
+      if (mysql_schema_table(this, lex, tables) == false)
         continue;
       return -1;
     }
@@ -2702,12 +2531,10 @@
       not opened yet. Try to open the table.
     */
     if (tables->table == NULL)
-      tables->table= open_table(session, tables, &refresh, flags);
+      tables->table= open_table(tables, &refresh, flags);
 
     if (tables->table == NULL)
     {
-      free_root(&new_frm_mem, MYF(MY_KEEP_PREALLOC));
-
       if (refresh)				// Refresh in progress
       {
         /*
@@ -2724,7 +2551,7 @@
           we pretend that we have finished calculation which we were doing
           currently.
         */
-        session->close_tables_for_reopen(start);
+        close_tables_for_reopen(start);
         goto restart;
       }
 
@@ -2734,17 +2561,16 @@
       result= -1;				// Fatal error
       break;
     }
-    if (tables->lock_type != TL_UNLOCK && ! session->locked_tables)
+    if (tables->lock_type != TL_UNLOCK)
     {
       if (tables->lock_type == TL_WRITE_DEFAULT)
-        tables->table->reginfo.lock_type= session->update_lock_default;
+        tables->table->reginfo.lock_type= update_lock_default;
       else if (tables->table->s->tmp_table == NO_TMP_TABLE)
         tables->table->reginfo.lock_type= tables->lock_type;
     }
   }
 
-  session->set_proc_info(0);
-  free_root(&new_frm_mem, MYF(0));              // Free pre-alloced block
+  set_proc_info(0);
 
   if (result && tables)
   {
@@ -2754,45 +2580,12 @@
     */
     tables->table= NULL;
   }
+
   return(result);
 }
 
 
 /*
-  Check that lock is ok for tables; Call start stmt if ok
-
-  SYNOPSIS
-  check_lock_and_start_stmt()
-  session			Thread handle
-  table_list		Table to check
-  lock_type		Lock used for table
-
-  RETURN VALUES
-  0	ok
-  1	error
-*/
-
-static bool check_lock_and_start_stmt(Session *session, Table *table,
-                                      thr_lock_type lock_type)
-{
-  int error;
-
-  if ((int) lock_type >= (int) TL_WRITE_ALLOW_READ &&
-      (int) table->reginfo.lock_type < (int) TL_WRITE_ALLOW_READ)
-  {
-    my_error(ER_TABLE_NOT_LOCKED_FOR_WRITE, MYF(0),table->alias);
-    return 1;
-  }
-  if ((error=table->file->start_stmt(session, lock_type)))
-  {
-    table->file->print_error(error,MYF(0));
-    return 1;
-  }
-  return 0;
-}
-
-
-/*
   Open and lock one table
 
   SYNOPSIS
@@ -2816,14 +2609,14 @@
   table_list->table		table
 */
 
-Table *open_ltable(Session *session, TableList *table_list, thr_lock_type lock_type)
+Table *Session::open_ltable(TableList *table_list, thr_lock_type lock_type)
 {
   Table *table;
   bool refresh;
 
-  session->set_proc_info("Opening table");
-  session->current_tablenr= 0;
-  while (!(table= open_table(session, table_list, &refresh, 0)) &&
+  set_proc_info("Opening table");
+  current_tablenr= 0;
+  while (!(table= open_table(table_list, &refresh, 0)) &&
          refresh)
     ;
 
@@ -2831,102 +2624,16 @@
   {
     table_list->lock_type= lock_type;
     table_list->table=	   table;
-    if (session->locked_tables)
-    {
-      if (check_lock_and_start_stmt(session, table, lock_type))
+
+    assert(lock == 0);	// You must lock everything at once
+    if ((table->reginfo.lock_type= lock_type) != TL_UNLOCK)
+      if (! (lock= mysql_lock_tables(this, &table_list->table, 1, 0, &refresh)))
         table= 0;
-    }
-    else
-    {
-      assert(session->lock == 0);	// You must lock everything at once
-      if ((table->reginfo.lock_type= lock_type) != TL_UNLOCK)
-        if (! (session->lock= mysql_lock_tables(session, &table_list->table, 1, 0, &refresh)))
-          table= 0;
-    }
-  }
-
-  session->set_proc_info(0);
-  return(table);
-}
-
-
-/*
-  Open all tables in list, locks them and optionally process derived tables.
-
-  SYNOPSIS
-  open_and_lock_tables_derived()
-  session		- thread handler
-  tables	- list of tables for open&locking
-  derived     - if to handle derived tables
-
-  RETURN
-  false - ok
-  true  - error
-
-  NOTE
-  The lock will automaticaly be freed by close_thread_tables()
-
-  NOTE
-  There are two convenience functions:
-  - simple_open_n_lock_tables(session, tables)  without derived handling
-  - open_and_lock_tables(session, tables)       with derived handling
-  Both inline functions call open_and_lock_tables_derived() with
-  the third argument set appropriately.
-*/
-
-int open_and_lock_tables_derived(Session *session, TableList *tables, bool derived)
-{
-  uint32_t counter;
-  bool need_reopen;
-
-  for ( ; ; )
-  {
-    if (open_tables(session, &tables, &counter, 0))
-      return -1;
-
-    if (!lock_tables(session, tables, counter, &need_reopen))
-      break;
-    if (!need_reopen)
-      return -1;
-    session->close_tables_for_reopen(&tables);
-  }
-  if (derived &&
-      (mysql_handle_derived(session->lex, &mysql_derived_prepare) ||
-       (session->fill_derived_tables() &&
-        mysql_handle_derived(session->lex, &mysql_derived_filling))))
-    return true; /* purecov: inspected */
-  return 0;
-}
-
-
-/*
-  Open all tables in list and process derived tables
-
-  SYNOPSIS
-  open_normal_and_derived_tables
-  session		- thread handler
-  tables	- list of tables for open
-  flags       - bitmap of flags to modify how the tables will be open:
-  DRIZZLE_LOCK_IGNORE_FLUSH - open table even if someone has
-  done a flush or namelock on it.
-
-  RETURN
-  false - ok
-  true  - error
-
-  NOTE
-  This is to be used on prepare stage when you don't read any
-  data from the tables.
-*/
-
-bool open_normal_and_derived_tables(Session *session, TableList *tables, uint32_t flags)
-{
-  uint32_t counter;
-  assert(!session->fill_derived_tables());
-  if (open_tables(session, &tables, &counter, flags) ||
-      mysql_handle_derived(session->lex, &mysql_derived_prepare))
-    return true; /* purecov: inspected */
-  return 0;
+  }
+
+  set_proc_info(0);
+
+  return table;
 }
 
 /*
@@ -2970,47 +2677,22 @@
   if (tables == NULL)
     return 0;
 
-  if (!session->locked_tables)
+  assert(session->lock == 0);	// You must lock everything at once
+  Table **start,**ptr;
+  uint32_t lock_flag= DRIZZLE_LOCK_NOTIFY_IF_NEED_REOPEN;
+
+  if (!(ptr=start=(Table**) session->alloc(sizeof(Table*)*count)))
+    return -1;
+  for (table= tables; table; table= table->next_global)
   {
-    assert(session->lock == 0);	// You must lock everything at once
-    Table **start,**ptr;
-    uint32_t lock_flag= DRIZZLE_LOCK_NOTIFY_IF_NEED_REOPEN;
-
-    if (!(ptr=start=(Table**) session->alloc(sizeof(Table*)*count)))
-      return -1;
-    for (table= tables; table; table= table->next_global)
-    {
-      if (!table->placeholder())
-        *(ptr++)= table->table;
-    }
-
-    if (!(session->lock= mysql_lock_tables(session, start, (uint32_t) (ptr - start),
-                                           lock_flag, need_reopen)))
-    {
-      return -1;
-    }
+    if (!table->placeholder())
+      *(ptr++)= table->table;
   }
-  else
+
+  if (!(session->lock= mysql_lock_tables(session, start, (uint32_t) (ptr - start),
+                                         lock_flag, need_reopen)))
   {
-    TableList *first_not_own= session->lex->first_not_own_table();
-    /*
-      When open_and_lock_tables() is called for a single table out of
-      a table list, the 'next_global' chain is temporarily broken. We
-      may not find 'first_not_own' before the end of the "list".
-      Look for example at those places where open_n_lock_single_table()
-      is called. That function implements the temporary breaking of
-      a table list for opening a single table.
-    */
-    for (table= tables;
-         table && table != first_not_own;
-         table= table->next_global)
-    {
-      if (!table->placeholder() &&
-          check_lock_and_start_stmt(session, table->table, table->lock_type))
-      {
-        return -1;
-      }
-    }
+    return -1;
   }
 
   return 0;
@@ -3018,32 +2700,6 @@
 
 
 /*
-  Prepare statement for reopening of tables and recalculation of set of
-  prelocked tables.
-
-  SYNOPSIS
-  close_tables_for_reopen()
-  session    in     Thread context
-  tables in/out List of tables which we were trying to open and lock
-
-*/
-
-void Session::close_tables_for_reopen(TableList **tables)
-{
-  /*
-    If table list consists only from tables from prelocking set, table list
-    for new attempt should be empty, so we have to update list's root pointer.
-  */
-  if (lex->first_not_own_table() == *tables)
-    *tables= 0;
-  lex->chop_off_not_own_tables();
-  for (TableList *tmp= *tables; tmp; tmp= tmp->next_global)
-    tmp->table= 0;
-  close_thread_tables();
-}
-
-
-/*
   Open a single table without table caching and don't set it in open_list
 
   SYNPOSIS
@@ -3076,7 +2732,7 @@
   table_list.db=         (char*) db;
   table_list.table_name= (char*) table_name;
   /* Create the cache_key for temporary tables */
-  key_length= create_table_def_key(cache_key, &table_list);
+  key_length= table_list.create_table_def_key(cache_key);
   path_length= strlen(path);
 
   if (!(tmp_table= (Table*) malloc(sizeof(*tmp_table) + sizeof(*share) +
@@ -3524,52 +3180,6 @@
 
 
 /*
-  Find field in table, no side effects, only purpose is to check for field
-  in table object and get reference to the field if found.
-
-  SYNOPSIS
-  find_field_in_table_sef()
-
-  table                         table where to find
-  name                          Name of field searched for
-
-  RETURN
-  0                   field is not found
-#                   pointer to field
-*/
-
-Field *find_field_in_table_sef(Table *table, const char *name)
-{
-  Field **field_ptr;
-  if (table->s->name_hash.records)
-  {
-    field_ptr= (Field**)hash_search(&table->s->name_hash,(unsigned char*) name,
-                                    strlen(name));
-    if (field_ptr)
-    {
-      /*
-        field_ptr points to field in TableShare. Convert it to the matching
-        field in table
-      */
-      field_ptr= (table->field + (field_ptr - table->s->field));
-    }
-  }
-  else
-  {
-    if (!(field_ptr= table->field))
-      return (Field *)0;
-    for (; *field_ptr; ++field_ptr)
-      if (!my_strcasecmp(system_charset_info, (*field_ptr)->field_name, name))
-        break;
-  }
-  if (field_ptr)
-    return *field_ptr;
-  else
-    return (Field *)0;
-}
-
-
-/*
   Find field in table list.
 
   SYNOPSIS
@@ -4909,7 +4519,6 @@
                                    bool select_insert)
 {
   TableList *leaves_tmp= NULL;
-  bool first_table= true;
 
   if (setup_tables(session, context, from_clause, tables,
                    &leaves_tmp, select_insert))
@@ -4918,10 +4527,6 @@
   if (leaves)
     *leaves= leaves_tmp;
 
-  for (; leaves_tmp; leaves_tmp= leaves_tmp->next_leaf)
-  {
-    first_table= 0;
-  }
   return false;
 }
 
@@ -5478,6 +5083,8 @@
 
 void remove_db_from_cache(const char *db)
 {
+  safe_mutex_assert_owner(&LOCK_open);
+
   for (uint32_t idx=0 ; idx < open_cache.records ; idx++)
   {
     Table *table=(Table*) hash_element(&open_cache,idx);

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2009-06-06 00:09:29 +0000
+++ drizzled/sql_base.h	2009-06-08 22:21:27 +0000
@@ -59,12 +59,9 @@
 void add_join_on(TableList *b,Item *expr);
 void add_join_natural(TableList *a,TableList *b,List<String> *using_fields,
                       Select_Lex *lex);
-void unlink_open_table(Session *session, Table *find, bool unlock);
+void unlink_open_table(Session *session, Table *find);
 void drop_open_table(Session *session, Table *table, const char *db_name,
                      const char *table_name);
-void update_non_unique_table_error(TableList *update,
-                                   const char *operation,
-                                   TableList *duplicate);
 
 SQL_SELECT *make_select(Table *head, table_map const_tables,
 			table_map read_tables, COND *conds,
@@ -136,14 +133,9 @@
 int init_ftfuncs(Session *session, Select_Lex* select, bool no_order);
 void wait_for_condition(Session *session, pthread_mutex_t *mutex,
                         pthread_cond_t *cond);
-int open_tables(Session *session, TableList **tables, uint32_t *counter, uint32_t flags);
+int open_tables_from_list(Session *session, TableList **tables, uint32_t *counter, uint32_t flags);
 /* open_and_lock_tables with optional derived handling */
 int open_and_lock_tables_derived(Session *session, TableList *tables, bool derived);
-/* open_and_lock_tables with derived handling */
-inline int open_and_lock_tables(Session *session, TableList *tables)
-{
-  return open_and_lock_tables_derived(session, tables, true);
-}
 bool open_normal_and_derived_tables(Session *session, TableList *tables, uint32_t flags);
 int lock_tables(Session *session, TableList *tables, uint32_t counter, bool *need_reopen);
 int decide_logging_format(Session *session);

=== modified file 'drizzled/sql_delete.cc'
--- drizzled/sql_delete.cc	2009-06-02 09:09:44 +0000
+++ drizzled/sql_delete.cc	2009-06-08 22:21:27 +0000
@@ -52,7 +52,7 @@
   Session::killed_state killed_status= Session::NOT_KILLED;
 
 
-  if (open_and_lock_tables(session, table_list))
+  if (session->open_and_lock_tables(table_list))
     return(true);
 
   table= table_list->table;
@@ -366,7 +366,7 @@
     TableList *duplicate;
     if ((duplicate= unique_table(session, table_list, table_list->next_global, 0)))
     {
-      update_non_unique_table_error(table_list, "DELETE", duplicate);
+      my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->alias);
       return(true);
     }
   }
@@ -443,13 +443,14 @@
       if ((duplicate= unique_table(session, target_tbl->correspondent_table,
                                    lex->query_tables, 0)))
       {
-        update_non_unique_table_error(target_tbl->correspondent_table,
-                                      "DELETE", duplicate);
-        return(true);
+        my_error(ER_UPDATE_TABLE_USED, MYF(0), target_tbl->correspondent_table->alias);
+
+        return true;
       }
     }
   }
-  return(false);
+
+  return false;
 }
 
 
@@ -791,7 +792,7 @@
 
   memset(&create_info, 0, sizeof(create_info));
   /* If it is a temporary table, close and regenerate it */
-  if (!dont_send_ok && (table= find_temporary_table(session, table_list)))
+  if (!dont_send_ok && (table= session->find_temporary_table(table_list)))
   {
     StorageEngine *table_type= table->s->db_type();
     TableShare *share= table->s;
@@ -801,7 +802,7 @@
 
     table->file->info(HA_STATUS_AUTO | HA_STATUS_NO_LOCK);
 
-    close_temporary_table(session, table, 0, 0);    // Don't free share
+    session->close_temporary_table(table, false, false);    // Don't free share
     ha_create_table(session, share->normalized_path.str,
                     share->db.str, share->table_name.str, &create_info, 1);
     // We don't need to call invalidate() because this table is not in cache

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2009-06-02 09:09:44 +0000
+++ drizzled/sql_insert.cc	2009-06-09 00:45:39 +0000
@@ -239,7 +239,7 @@
   upgrade_lock_type(session, &table_list->lock_type, duplic,
                     values_list.elements > 1);
 
-  if (open_and_lock_tables(session, table_list))
+  if (session->open_and_lock_tables(table_list))
     return(true);
 
   lock_type= table_list->lock_type;
@@ -656,13 +656,15 @@
     TableList *duplicate;
     if ((duplicate= unique_table(session, table_list, table_list->next_global, 1)))
     {
-      update_non_unique_table_error(table_list, "INSERT", duplicate);
-      return(true);
+      my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->alias);
+
+      return true;
     }
   }
   if (duplic == DUP_UPDATE || duplic == DUP_REPLACE)
     table->prepare_for_position();
-  return(false);
+
+  return false;
 }
 
 
@@ -1470,11 +1472,11 @@
       push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_NOTE,
                           ER_TABLE_EXISTS_ERROR, ER(ER_TABLE_EXISTS_ERROR),
                           create_table->table_name);
-      return(create_table->table);
+      return create_table->table;
     }
 
     my_error(ER_TABLE_EXISTS_ERROR, MYF(0), create_table->table_name);
-    return(0);
+    return NULL;
   }
 
   tmp_table.alias= 0;
@@ -1506,7 +1508,7 @@
 	!(cr_field=new Create_field(field,(item->type() == Item::FIELD_ITEM ?
 					   ((Item_field *)item)->field :
 					   (Field*) 0))))
-      return(0);
+      return NULL;
     if (item->maybe_null)
       cr_field->flags &= ~NOT_NULL_FLAG;
     alter_info->create_list.push_back(cr_field);
@@ -1540,13 +1542,13 @@
           cluster. We don't have much options but throw an error.
         */
         my_error(ER_TABLE_EXISTS_ERROR, MYF(0), create_table->table_name);
-        return(0);
+        return NULL;
       }
 
       if (!(create_info->options & HA_LEX_CREATE_TMP_TABLE))
       {
         pthread_mutex_lock(&LOCK_open); /* CREATE TABLE... has found that the table already exists for insert and is adapting to use it */
-        if (reopen_name_locked_table(session, create_table, false))
+        if (session->reopen_name_locked_table(create_table, false))
         {
           quick_rm_table(create_info->db_type, create_table->db,
                          create_table->table_name, false);
@@ -1557,8 +1559,8 @@
       }
       else
       {
-        if (!(table= open_table(session, create_table, (bool*) 0,
-                                DRIZZLE_OPEN_TEMPORARY_ONLY)) &&
+        if (!(table= session->open_table(create_table, (bool*) 0,
+                                         DRIZZLE_OPEN_TEMPORARY_ONLY)) &&
             !create_info->table_existed)
         {
           /*
@@ -1566,12 +1568,12 @@
             it preparable for open. But let us do close_temporary_table() here
             just in case.
           */
-          drop_temporary_table(session, create_table);
+          session->drop_temporary_table(create_table);
         }
       }
     }
     if (!table)                                   // open failed
-      return(0);
+      return NULL;
   }
 
   table->reginfo.lock_type=TL_WRITE;
@@ -1585,10 +1587,11 @@
     }
 
     if (!create_info->table_existed)
-      drop_open_table(session, table, create_table->db, create_table->table_name);
-    return(0);
+      session->drop_open_table(table, create_table->db, create_table->table_name);
+    return NULL;
   }
-  return(table);
+
+  return table;
 }
 
 
@@ -1767,10 +1770,9 @@
     table->file->extra(HA_EXTRA_NO_IGNORE_DUP_KEY);
     table->file->extra(HA_EXTRA_WRITE_CANNOT_REPLACE);
     if (!create_info->table_existed)
-      drop_open_table(session, table, create_table->db, create_table->table_name);
-    table=0;                                    // Safety
+      session->drop_open_table(table, create_table->db, create_table->table_name);
+    table= NULL;                                    // Safety
   }
-  return;
 }
 
 

=== modified file 'drizzled/sql_load.cc'
--- drizzled/sql_load.cc	2009-05-23 05:46:14 +0000
+++ drizzled/sql_load.cc	2009-06-08 22:21:27 +0000
@@ -136,7 +136,7 @@
     my_error(ER_WRONG_FIELD_TERMINATORS,MYF(0),enclosed->c_ptr(), enclosed->length());
     return(true);
   }
-  if (open_and_lock_tables(session, table_list))
+  if (session->open_and_lock_tables(table_list))
     return(true);
   if (setup_tables_and_check_access(session, &session->lex->select_lex.context,
                                     &session->lex->select_lex.top_join_list,

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-06-06 01:45:22 +0000
+++ drizzled/sql_parse.cc	2009-06-08 22:21:27 +0000
@@ -67,16 +67,6 @@
   "NON-EXISTING", "ACTIVE", "IDLE", "PREPARED"
 };
 
-static void unlock_locked_tables(Session *session)
-{
-  if (session->locked_tables)
-  {
-    session->lock= session->locked_tables;
-    session->locked_tables= 0;			// Will be automatically closed
-    session->close_thread_tables();			// Free tables
-  }
-}
-
 /**
   Mark all commands that somehow changes a table.
 
@@ -630,8 +620,7 @@
       TABLE in the same way. That way we avoid that a new table is
       created during a gobal read lock.
     */
-    if (!session->locked_tables &&
-        !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+    if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
     {
       res= 1;
       goto end_with_restore_list;
@@ -649,7 +638,7 @@
         create_table->create= true;
       }
 
-      if (!(res= open_and_lock_tables(session, lex->query_tables)))
+      if (!(res= session->open_and_lock_tables(lex->query_tables)))
       {
         /*
           Is table which we are changing used somewhere in other parts
@@ -661,7 +650,7 @@
           create_table= lex->unlink_first_table(&link_to_local);
           if ((duplicate= unique_table(session, create_table, select_tables, 0)))
           {
-            update_non_unique_table_error(create_table, "CREATE", duplicate);
+            my_error(ER_UPDATE_TABLE_USED, MYF(0), create_table->alias);
             res= 1;
             goto end_with_restore_list;
           }
@@ -788,8 +777,7 @@
       if (! session->endActiveTransaction())
 	goto error;
 
-      if (!session->locked_tables &&
-          !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+      if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
       {
         res= 1;
         break;
@@ -918,8 +906,7 @@
     if ((res= insert_precheck(session, all_tables)))
       break;
 
-    if (!session->locked_tables &&
-        !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+    if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
     {
       res= 1;
       break;
@@ -944,14 +931,13 @@
 
     unit->set_limit(select_lex);
 
-    if (! session->locked_tables &&
-        ! (need_start_waiting= ! wait_if_global_read_lock(session, 0, 1)))
+    if (! (need_start_waiting= ! wait_if_global_read_lock(session, 0, 1)))
     {
       res= 1;
       break;
     }
 
-    if (!(res= open_and_lock_tables(session, all_tables)))
+    if (!(res= session->open_and_lock_tables(all_tables)))
     {
       /* Skip first table, which is the table we are inserting in */
       TableList *second_table= first_table->next_local;
@@ -1001,7 +987,7 @@
       Don't allow this within a transaction because we want to use
       re-generate table
     */
-    if (session->locked_tables || session->inTransaction())
+    if (session->inTransaction())
     {
       my_message(ER_LOCK_OR_ACTIVE_TRANSACTION, ER(ER_LOCK_OR_ACTIVE_TRANSACTION), MYF(0));
       goto error;
@@ -1016,8 +1002,7 @@
     assert(select_lex->offset_limit == 0);
     unit->set_limit(select_lex);
 
-    if (!session->locked_tables &&
-        !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+    if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
     {
       res= 1;
       break;
@@ -1036,8 +1021,7 @@
       (TableList *)session->lex->auxiliary_table_list.first;
     multi_delete *del_result;
 
-    if (!session->locked_tables &&
-        !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+    if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
     {
       res= 1;
       break;
@@ -1053,7 +1037,7 @@
       goto error;
 
     session->set_proc_info("init");
-    if ((res= open_and_lock_tables(session, all_tables)))
+    if ((res= session->open_and_lock_tables(all_tables)))
       break;
 
     if ((res= mysql_multi_delete_prepare(session)))
@@ -1126,7 +1110,7 @@
   {
     List<set_var_base> *lex_var_list= &lex->var_list;
 
-    if (open_and_lock_tables(session, all_tables))
+    if (session->open_and_lock_tables(all_tables))
       goto error;
     if (!(res= sql_set_variables(session, lex_var_list)))
     {
@@ -1154,12 +1138,6 @@
       done FLUSH TABLES WITH READ LOCK + BEGIN. If this assumption becomes
       false, mysqldump will not work.
     */
-    unlock_locked_tables(session);
-    if (session->options & OPTION_TABLE_LOCK)
-    {
-      (void) session->endActiveTransaction();
-      session->options&= ~(OPTION_TABLE_LOCK);
-    }
     if (session->global_read_lock)
       unlock_global_read_lock(session);
     session->my_ok();
@@ -1199,7 +1177,7 @@
       my_error(ER_WRONG_DB_NAME, MYF(0), lex->name.str);
       break;
     }
-    if (session->locked_tables || session->inTransaction())
+    if (session->inTransaction())
     {
       my_message(ER_LOCK_OR_ACTIVE_TRANSACTION, ER(ER_LOCK_OR_ACTIVE_TRANSACTION), MYF(0));
       goto error;
@@ -1216,7 +1194,7 @@
       my_error(ER_WRONG_DB_NAME, MYF(0), db->str);
       break;
     }
-    if (session->locked_tables || session->inTransaction())
+    if (session->inTransaction())
     {
       my_message(ER_LOCK_OR_ACTIVE_TRANSACTION, ER(ER_LOCK_OR_ACTIVE_TRANSACTION), MYF(0));
       goto error;
@@ -1430,7 +1408,7 @@
       param->select_limit=
         new Item_int((uint64_t) session->variables.select_limit);
   }
-  if (!(res= open_and_lock_tables(session, all_tables)))
+  if (!(res= session->open_and_lock_tables(all_tables)))
   {
     if (lex->describe)
     {
@@ -2434,34 +2412,16 @@
   {
     if ((options & REFRESH_READ_LOCK) && session)
     {
-      /*
-        We must not try to aspire a global read lock if we have a write
-        locked table. This would lead to a deadlock when trying to
-        reopen (and re-lock) the table after the flush.
-      */
-      if (session->locked_tables)
-      {
-        THR_LOCK_DATA **lock_p= session->locked_tables->locks;
-        THR_LOCK_DATA **end_p= lock_p + session->locked_tables->lock_count;
-
-        for (; lock_p < end_p; lock_p++)
-        {
-          if ((*lock_p)->type >= TL_WRITE_ALLOW_WRITE)
-          {
-            my_error(ER_LOCK_OR_ACTIVE_TRANSACTION, MYF(0));
-            return 1;
-          }
-        }
-      }
       if (lock_global_read_lock(session))
-	return 1;                               // Killed
+	return true;                               // Killed
       result= close_cached_tables(session, tables, (options & REFRESH_FAST) ?
                                   false : true, true);
       if (make_global_read_lock_block_commit(session)) // Killed
       {
         /* Don't leave things in a half-locked state */
         unlock_global_read_lock(session);
-        return 1;
+
+        return true;
       }
     }
     else

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-06-03 18:58:23 +0000
+++ drizzled/sql_select.cc	2009-06-09 01:59:10 +0000
@@ -8351,8 +8351,8 @@
   @param tables  list of tables in join
   @query_type    type of the query is being generated
 */
-static void print_join(Session *session, String *str,
-                       List<TableList> *tables, enum_query_type)
+void print_join(Session *session, String *str,
+                List<TableList> *tables, enum_query_type)
 {
   /* List is reversed => we should reverse it before using */
   List_iterator_fast<TableList> ti(*tables);
@@ -8386,78 +8386,6 @@
   print_table_array(session, str, table, table + tables->elements);
 }
 
-/**
-  Print table as it should be in join list.
-
-  @param str   string where table should be printed
-*/
-void TableList::print(Session *session, String *str, enum_query_type query_type)
-{
-  if (nested_join)
-  {
-    str->append('(');
-    print_join(session, str, &nested_join->join_list, query_type);
-    str->append(')');
-  }
-  else
-  {
-    const char *cmp_name;                         // Name to compare with alias
-    if (derived)
-    {
-      // A derived table
-      str->append('(');
-      derived->print(str, query_type);
-      str->append(')');
-      cmp_name= "";                               // Force printing of alias
-    }
-    else
-    {
-      // A normal table
-      {
-        str->append_identifier(db, db_length);
-        str->append('.');
-      }
-      if (schema_table)
-      {
-        str->append_identifier(schema_table_name, strlen(schema_table_name));
-        cmp_name= schema_table_name;
-      }
-      else
-      {
-        str->append_identifier(table_name, table_name_length);
-        cmp_name= table_name;
-      }
-    }
-    if (my_strcasecmp(table_alias_charset, cmp_name, alias))
-    {
-
-      if (alias && alias[0])
-      {
-        str->append(' ');
-
-        string t_alias(alias);
-        transform(t_alias.begin(), t_alias.end(),
-                  t_alias.begin(), ::tolower);
-
-        str->append_identifier(t_alias.c_str(), t_alias.length());
-      }
-
-    }
-
-    if (index_hints)
-    {
-      List_iterator<Index_hint> it(*index_hints);
-      Index_hint *hint;
-
-      while ((hint= it++))
-      {
-        str->append (STRING_WITH_LEN(" "));
-        hint->print (session, str);
-      }
-    }
-  }
-}
-
 void Select_Lex::print(Session *session, String *str, enum_query_type query_type)
 {
   /* QQ: session may not be set for sub queries, but this should be fixed */

=== modified file 'drizzled/sql_select.h'
--- drizzled/sql_select.h	2009-06-08 16:27:18 +0000
+++ drizzled/sql_select.h	2009-06-09 01:59:10 +0000
@@ -410,4 +410,7 @@
 COND *remove_eq_conds(Session *session, COND *cond, Item::cond_result *cond_value);
 int test_if_item_cache_changed(List<Cached_item> &list);
 
+void print_join(Session *session, String *str,
+                List<TableList> *tables, enum_query_type);
+
 #endif /* DRIZZLED_SQL_SELECT_H */

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-06-08 01:32:13 +0000
+++ drizzled/sql_table.cc	2009-06-09 01:58:43 +0000
@@ -328,8 +328,7 @@
 
   if (!drop_temporary)
   {
-    if (!session->locked_tables &&
-        !(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
+    if (!(need_start_waiting= !wait_if_global_read_lock(session, 0, 1)))
       return(true);
   }
 
@@ -430,7 +429,7 @@
     char *db=table->db;
     StorageEngine *table_type;
 
-    error= drop_temporary_table(session, table);
+    error= session->drop_temporary_table(table);
 
     switch (error) {
     case  0:
@@ -1693,8 +1692,8 @@
   if (mysql_prepare_create_table(session, create_info, alter_info,
                                  internal_tmp_table,
                                  &db_options, file,
-			  &key_info_buffer, &key_count,
-			  select_field_count))
+                                 &key_info_buffer, &key_count,
+                                 select_field_count))
     goto err;
 
       /* Check if table exists */
@@ -1718,7 +1717,7 @@
 
   /* Check if table already exists */
   if ((create_info->options & HA_LEX_CREATE_TMP_TABLE) &&
-      find_temporary_table(session, db, table_name))
+      session->find_temporary_table(db, table_name))
   {
     if (create_info->options & HA_LEX_CREATE_IF_NOT_EXISTS)
     {
@@ -1879,17 +1878,17 @@
                         bool internal_tmp_table,
                         uint32_t select_field_count)
 {
-  Table *name_lock= 0;
+  Table *name_lock= NULL;
   bool result;
 
   if (!(create_info->options & HA_LEX_CREATE_TMP_TABLE))
   {
-    if (lock_table_name_if_not_cached(session, db, table_name, &name_lock))
+    if (session->lock_table_name_if_not_cached(db, table_name, &name_lock))
     {
       result= true;
       goto unlock;
     }
-    if (!name_lock)
+    if (name_lock == NULL)
     {
       if (create_info->options & HA_LEX_CREATE_IF_NOT_EXISTS)
       {
@@ -1918,7 +1917,7 @@
   if (name_lock)
   {
     pthread_mutex_lock(&LOCK_open); /* Lock for removing name_lock during table create */
-    unlink_open_table(session, name_lock, false);
+    session->unlink_open_table(name_lock);
     pthread_mutex_unlock(&LOCK_open);
   }
 
@@ -2080,18 +2079,18 @@
     Win32 clients must also have a WRITE LOCK on the table !
 */
 
-void close_cached_table(Session *session, Table *table)
+void Session::close_cached_table(Table *table)
 {
 
-  wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
+  wait_while_table_is_used(this, table, HA_EXTRA_FORCE_REOPEN);
   /* Close lock if this is not got with LOCK TABLES */
-  if (session->lock)
+  if (lock)
   {
-    mysql_unlock_tables(session, session->lock);
-    session->lock= NULL;			// Start locked threads
+    mysql_unlock_tables(this, lock);
+    lock= NULL;			// Start locked threads
   }
   /* Close all copies of 'table'.  This also frees all LOCK TABLES lock */
-  unlink_open_table(session, table, true);
+  unlink_open_table(table);
 
   /* When lock on LOCK_open is freed other threads can continue */
   broadcast_refresh();
@@ -2132,7 +2131,7 @@
     char key[MAX_DBKEY_LENGTH];
     uint32_t key_length;
 
-    key_length= create_table_def_key(key, table_list);
+    key_length= table_list->create_table_def_key(key);
     pthread_mutex_lock(&LOCK_open); /* Lock table for repair */
     if (!(share= (get_table_share(session, table_list, key, key_length, 0,
                                   &error))))
@@ -2195,7 +2194,7 @@
   if (table_list->table)
   {
     pthread_mutex_lock(&LOCK_open); /* Close for repair table */
-    close_cached_table(session, table);
+    session->close_cached_table(table);
     pthread_mutex_unlock(&LOCK_open);
   }
   if (lock_and_wait_for_table_name(session,table_list))
@@ -2236,7 +2235,7 @@
     to finish the repair in the handler later on.
   */
   pthread_mutex_lock(&LOCK_open); /* Lock for opening partially repaired table */
-  if (reopen_name_locked_table(session, table_list, true))
+  if (session->reopen_name_locked_table(table_list, true))
   {
     unlock_table_name(table_list);
     pthread_mutex_unlock(&LOCK_open);
@@ -2329,7 +2328,7 @@
       lex->query_tables_own_last= 0;
       session->no_warnings_for_error= no_warnings_for_error;
 
-      open_and_lock_tables(session, table);
+      session->open_and_lock_tables(table);
       session->no_warnings_for_error= 0;
       table->next_global= save_next_global;
       table->next_local= save_next_local;
@@ -2544,7 +2543,7 @@
       session->close_thread_tables();
       if (!result_code) // recreation went ok
       {
-        if ((table->table= open_ltable(session, table, lock_type)) &&
+        if ((table->table= session->open_ltable(table, lock_type)) &&
             ((result_code= table->table->file->ha_analyze(session, check_opt)) > 0))
           result_code= 0; // analyze went ok
       }
@@ -2822,8 +2821,8 @@
     we ensure that our statement is properly isolated from all concurrent
     operations which matter.
   */
-  if (open_tables(session, &src_table, &not_used, 0))
-    return(true);
+  if (session->open_tables_from_list(&src_table, &not_used, 0))
+    return true;
 
   strncpy(src_path, src_table->table->s->path.str, sizeof(src_path));
 
@@ -2833,14 +2832,14 @@
   */
   if (create_info->options & HA_LEX_CREATE_TMP_TABLE)
   {
-    if (find_temporary_table(session, db, table_name))
+    if (session->find_temporary_table(db, table_name))
       goto table_exists;
     dst_path_length= build_tmptable_filename(session, dst_path, sizeof(dst_path));
     create_info->table_options|= HA_CREATE_DELAY_KEY_WRITE;
   }
   else
   {
-    if (lock_table_name_if_not_cached(session, db, table_name, &name_lock))
+    if (session->lock_table_name_if_not_cached(db, table_name, &name_lock))
       goto err;
     if (!name_lock)
       goto table_exists;
@@ -2951,7 +2950,7 @@
         */
         table->table= name_lock;
         pthread_mutex_lock(&LOCK_open); /* Open new table we have just acquired */
-        if (reopen_name_locked_table(session, table, false))
+        if (session->reopen_name_locked_table(table, false))
         {
           pthread_mutex_unlock(&LOCK_open);
           goto err;
@@ -2988,7 +2987,7 @@
   if (name_lock)
   {
     pthread_mutex_lock(&LOCK_open); /* unlink open tables for create table like*/
-    unlink_open_table(session, name_lock, false);
+    session->unlink_open_table(name_lock);
     pthread_mutex_unlock(&LOCK_open);
   }
   return(res);
@@ -3040,7 +3039,7 @@
    not complain when we lock the table
  */
   session->tablespace_op= true;
-  if (!(table= open_ltable(session, table_list, TL_WRITE)))
+  if (!(table= session->open_ltable(table_list, TL_WRITE)))
   {
     session->tablespace_op= false;
     return -1;
@@ -3694,7 +3693,7 @@
   if (table_list && table_list->schema_table)
   {
     my_error(ER_DBACCESS_DENIED_ERROR, MYF(0), "", "", INFORMATION_SCHEMA_NAME.c_str());
-    return(true);
+    return true;
   }
 
   /*
@@ -3732,7 +3731,7 @@
     This code is wrong and will be removed, please do not copy.
   */
 
-  if (!(table= open_ltable(session, table_list, TL_WRITE_ALLOW_READ)))
+  if (!(table= session->open_ltable(table_list, TL_WRITE_ALLOW_READ)))
     return true;
   table->use_all_columns();
 
@@ -3760,20 +3759,21 @@
     {
       if (table->s->tmp_table != NO_TMP_TABLE)
       {
-	if (find_temporary_table(session,new_db,new_name_buff))
+	if (session->find_temporary_table(new_db, new_name_buff))
 	{
 	  my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_name_buff);
-	  return(true);
+	  return true;
 	}
       }
       else
       {
-        if (lock_table_name_if_not_cached(session, new_db, new_name, &name_lock))
-          return(true);
+        if (session->lock_table_name_if_not_cached(new_db, new_name, &name_lock))
+          return true;
+
         if (!name_lock)
         {
 	  my_error(ER_TABLE_EXISTS_ERROR, MYF(0), new_alias);
-	  return(true);
+	  return true;
         }
 
         build_table_filename(new_name_buff, sizeof(new_name_buff),
@@ -3881,7 +3881,7 @@
         Then do a 'simple' rename of the table. First we need to close all
         instances of 'source' table.
       */
-      close_cached_table(session, table);
+      session->close_cached_table(table);
       /*
         Then, we want check once again that target table does not exist.
         Actually the order of these two steps does not matter since
@@ -3928,7 +3928,7 @@
       error= -1;
     }
     if (name_lock)
-      unlink_open_table(session, name_lock, false);
+      session->unlink_open_table(name_lock);
     pthread_mutex_unlock(&LOCK_open);
     table_list->table= NULL;                    // For query cache
     return(error);
@@ -3974,13 +3974,12 @@
   if (table->s->tmp_table)
   {
     TableList tbl;
-    memset(&tbl, 0, sizeof(tbl));
     tbl.db= new_db;
     tbl.alias= tmp_name;
     tbl.table_name= tmp_name;
 
     /* Table is in session->temporary_tables */
-    new_table= open_table(session, &tbl, (bool*) 0, DRIZZLE_LOCK_IGNORE_FLUSH);
+    new_table= session->open_table(&tbl, (bool*) 0, DRIZZLE_LOCK_IGNORE_FLUSH);
   }
   else
   {
@@ -4026,7 +4025,7 @@
       session->lock=0;
     }
     /* Remove link to old table and rename the new one */
-    close_temporary_table(session, table, true, true);
+    session->close_temporary_table(table, true, true);
     /* Should pass the 'new_name' as we store table name in the cache */
     if (rename_temporary_table(new_table, new_db, new_name))
       goto err1;
@@ -4115,13 +4114,6 @@
 
   quick_rm_table(old_db_type, db, old_name, true);
 
-  if (session->locked_tables && new_name == table_name && new_db == db)
-  {
-    error= session->reopen_tables(true, true);
-
-    if (error)
-      goto err_with_placeholders;
-  }
   pthread_mutex_unlock(&LOCK_open);
 
   session->set_proc_info("end");
@@ -4152,20 +4144,6 @@
   }
   table_list->table=0;				// For query cache
 
-  if (session->locked_tables && (new_name != table_name || new_db != db))
-  {
-    /*
-      If are we under LOCK TABLES and did ALTER Table with RENAME we need
-      to remove placeholders for the old table and for the target table
-      from the list of open tables and table cache. If we are not under
-      LOCK TABLES we can rely on close_thread_tables() doing this job.
-    */
-    pthread_mutex_lock(&LOCK_open); /* LOCK for ALTER TABLE, but this locks for LOCK TABLES */
-    unlink_open_table(session, table, false);
-    unlink_open_table(session, name_lock, false);
-    pthread_mutex_unlock(&LOCK_open);
-  }
-
 end_temporary:
   /*
    * Field::store() may have called my_error().  If this is 
@@ -4191,7 +4169,7 @@
   if (new_table)
   {
     /* close_temporary_table() frees the new_table pointer. */
-    close_temporary_table(session, new_table, true, true);
+    session->close_temporary_table(new_table, true, true);
   }
   else
     quick_rm_table(new_db_type, new_db, tmp_name, true);
@@ -4231,10 +4209,10 @@
   if (name_lock)
   {
     pthread_mutex_lock(&LOCK_open); /* ALTER TABLe */
-    unlink_open_table(session, name_lock, false);
+    session->unlink_open_table(name_lock);
     pthread_mutex_unlock(&LOCK_open);
   }
-  return(true);
+  return true;
 
 err_with_placeholders:
   /*
@@ -4242,9 +4220,9 @@
     being altered. To be safe under LOCK TABLES we should remove placeholders
     from list of open tables list and table cache.
   */
-  unlink_open_table(session, table, false);
+  session->unlink_open_table(table);
   if (name_lock)
-    unlink_open_table(session, name_lock, false);
+    session->unlink_open_table(name_lock);
   pthread_mutex_unlock(&LOCK_open);
   return(true);
 }
@@ -4519,7 +4497,7 @@
 
     sprintf(table_name,"%s.%s",table->db,table->table_name);
 
-    t= table->table= open_ltable(session, table, TL_READ);
+    t= table->table= session->open_ltable(table, TL_READ);
     session->clear_error();			// these errors shouldn't get client
 
     protocol->prepareForResend();

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2009-06-05 02:29:41 +0000
+++ drizzled/sql_update.cc	2009-06-08 22:21:27 +0000
@@ -29,42 +29,6 @@
 
 using namespace std;
 
-/*
-  check that all fields are real fields
-
-  SYNOPSIS
-    check_fields()
-    session             thread handler
-    items           Items for check
-
-  RETURN
-    true  Items can't be used in UPDATE
-    false Items are OK
-*/
-
-static bool check_fields(Session *session, List<Item> &items)
-{
-  List_iterator<Item> it(items);
-  Item *item;
-  Item_field *field;
-
-  while ((item= it++))
-  {
-    if (!(field= item->filed_for_view_update()))
-    {
-      /* item has name, because it comes from VIEW SELECT list */
-      my_error(ER_NONUPDATEABLE_COLUMN, MYF(0), item->name);
-      return true;
-    }
-    /*
-      we make temporary copy of Item_field, to avoid influence of changing
-      result_field on Item_ref which refer on this field
-    */
-    session->change_item_tree(it.ref(), new Item_field(session, field));
-  }
-  return false;
-}
-
 
 /**
   Re-read record if more columns are needed for error message.
@@ -178,7 +142,7 @@
 
   for ( ; ; )
   {
-    if (open_tables(session, &table_list, &table_count, 0))
+    if (session->open_tables_from_list(&table_list, &table_count, 0))
       return(1);
 
     if (!lock_tables(session, table_list, table_count, &need_reopen))
@@ -747,7 +711,6 @@
     TableList *duplicate;
     if ((duplicate= unique_table(session, table_list, table_list->next_global, 0)))
     {
-      update_non_unique_table_error(table_list, "UPDATE", duplicate);
       my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->table_name);
       return true;
     }
@@ -796,14 +759,12 @@
   TableList *tl, *leaves;
   List<Item> *fields= &lex->select_lex.item_list;
   table_map tables_for_update;
-  bool update_view= 0;
   /*
     if this multi-update was converted from usual update, here is table
     counter else junk will be assigned here, but then replaced with real
     count in open_tables()
   */
   uint32_t  table_count= lex->table_count;
-  const bool using_lock_tables= session->locked_tables != 0;
   bool original_multiupdate= (session->lex->sql_command == SQLCOM_UPDATE_MULTI);
   bool need_reopen= false;
 
@@ -815,7 +776,7 @@
 
   /* open tables and create derived ones, but do not lock and fill them */
   if (((original_multiupdate || need_reopen) &&
-       open_tables(session, &table_list, &table_count, 0)) ||
+       session->open_tables_from_list(&table_list, &table_count, false)) ||
       mysql_handle_derived(lex, &mysql_derived_prepare))
     return true;
   /*
@@ -833,11 +794,6 @@
   if (setup_fields_with_no_wrap(session, 0, *fields, MARK_COLUMNS_WRITE, 0, 0))
     return true;
 
-  if (update_view && check_fields(session, *fields))
-  {
-    return true;
-  }
-
   tables_for_update= get_table_map(fields);
 
   /*
@@ -870,7 +826,7 @@
       tl->lock_type= TL_READ;
       tl->updating= 0;
       /* Update Table::lock_type accordingly. */
-      if (!tl->placeholder() && !using_lock_tables)
+      if (!tl->placeholder())
         tl->table->reginfo.lock_type= tl->lock_type;
     }
   }
@@ -911,7 +867,8 @@
       TableList *duplicate;
       if ((duplicate= unique_table(session, tl, table_list, 0)))
       {
-        update_non_unique_table_error(table_list, "UPDATE", duplicate);
+        my_error(ER_UPDATE_TABLE_USED, MYF(0), table_list->alias);
+
         return true;
       }
     }

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-06-05 18:49:23 +0000
+++ drizzled/table.cc	2009-06-08 06:23:32 +0000
@@ -1924,230 +1924,6 @@
 }
 
 
-/*
-  Create Item_field for each column in the table.
-
-  SYNPOSIS
-    Table::fill_item_list()
-      item_list          a pointer to an empty list used to store items
-
-  DESCRIPTION
-    Create Item_field object for each column in the table and
-    initialize it with the corresponding Field. New items are
-    created in the current Session memory root.
-
-  RETURN VALUE
-    0                    success
-    1                    out of memory
-*/
-
-bool Table::fill_item_list(List<Item> *item_list) const
-{
-  /*
-    All Item_field's created using a direct pointer to a field
-    are fixed in Item_field constructor.
-  */
-  for (Field **ptr= field; *ptr; ptr++)
-  {
-    Item_field *item= new Item_field(*ptr);
-    if (!item || item_list->push_back(item))
-      return true;
-  }
-  return false;
-}
-
-
-/*
-  Find underlying base tables (TableList) which represent given
-  table_to_find (Table)
-
-  SYNOPSIS
-    TableList::find_underlying_table()
-    table_to_find table to find
-
-  RETURN
-    0  table is not found
-    found table reference
-*/
-
-TableList *TableList::find_underlying_table(Table *table_to_find)
-{
-  /* is this real table and table which we are looking for? */
-  if (table == table_to_find)
-    return this;
-
-  return NULL;
-}
-
-
-bool TableList::placeholder()
-{
-  return derived || schema_table || (create && !table->getDBStat()) || !table;
-}
-
-
-/*
-  Set insert_values buffer
-
-  SYNOPSIS
-    set_insert_values()
-    mem_root   memory pool for allocating
-
-  RETURN
-    false - OK
-    TRUE  - out of memory
-*/
-
-bool TableList::set_insert_values(MEM_ROOT *mem_root)
-{
-  if (table)
-  {
-    if (!table->insert_values &&
-        !(table->insert_values= (unsigned char *)alloc_root(mem_root,
-                                                   table->s->rec_buff_length)))
-      return true;
-  }
-
-  return false;
-}
-
-
-/*
-  Test if this is a leaf with respect to name resolution.
-
-  SYNOPSIS
-    TableList::is_leaf_for_name_resolution()
-
-  DESCRIPTION
-    A table reference is a leaf with respect to name resolution if
-    it is either a leaf node in a nested join tree (table, view,
-    schema table, subquery), or an inner node that represents a
-    NATURAL/USING join, or a nested join with materialized join
-    columns.
-
-  RETURN
-    TRUE if a leaf, false otherwise.
-*/
-bool TableList::is_leaf_for_name_resolution()
-{
-  return (is_natural_join || is_join_columns_complete || !nested_join);
-}
-
-
-/*
-  Retrieve the first (left-most) leaf in a nested join tree with
-  respect to name resolution.
-
-  SYNOPSIS
-    TableList::first_leaf_for_name_resolution()
-
-  DESCRIPTION
-    Given that 'this' is a nested table reference, recursively walk
-    down the left-most children of 'this' until we reach a leaf
-    table reference with respect to name resolution.
-
-  IMPLEMENTATION
-    The left-most child of a nested table reference is the last element
-    in the list of children because the children are inserted in
-    reverse order.
-
-  RETURN
-    If 'this' is a nested table reference - the left-most child of
-      the tree rooted in 'this',
-    else return 'this'
-*/
-
-TableList *TableList::first_leaf_for_name_resolution()
-{
-  TableList *cur_table_ref= NULL;
-  nested_join_st *cur_nested_join;
-
-  if (is_leaf_for_name_resolution())
-    return this;
-  assert(nested_join);
-
-  for (cur_nested_join= nested_join;
-       cur_nested_join;
-       cur_nested_join= cur_table_ref->nested_join)
-  {
-    List_iterator_fast<TableList> it(cur_nested_join->join_list);
-    cur_table_ref= it++;
-    /*
-      If the current nested join is a RIGHT JOIN, the operands in
-      'join_list' are in reverse order, thus the first operand is
-      already at the front of the list. Otherwise the first operand
-      is in the end of the list of join operands.
-    */
-    if (!(cur_table_ref->outer_join & JOIN_TYPE_RIGHT))
-    {
-      TableList *next;
-      while ((next= it++))
-        cur_table_ref= next;
-    }
-    if (cur_table_ref->is_leaf_for_name_resolution())
-      break;
-  }
-  return cur_table_ref;
-}
-
-
-/*
-  Retrieve the last (right-most) leaf in a nested join tree with
-  respect to name resolution.
-
-  SYNOPSIS
-    TableList::last_leaf_for_name_resolution()
-
-  DESCRIPTION
-    Given that 'this' is a nested table reference, recursively walk
-    down the right-most children of 'this' until we reach a leaf
-    table reference with respect to name resolution.
-
-  IMPLEMENTATION
-    The right-most child of a nested table reference is the first
-    element in the list of children because the children are inserted
-    in reverse order.
-
-  RETURN
-    - If 'this' is a nested table reference - the right-most child of
-      the tree rooted in 'this',
-    - else - 'this'
-*/
-
-TableList *TableList::last_leaf_for_name_resolution()
-{
-  TableList *cur_table_ref= this;
-  nested_join_st *cur_nested_join;
-
-  if (is_leaf_for_name_resolution())
-    return this;
-  assert(nested_join);
-
-  for (cur_nested_join= nested_join;
-       cur_nested_join;
-       cur_nested_join= cur_table_ref->nested_join)
-  {
-    cur_table_ref= cur_nested_join->join_list.head();
-    /*
-      If the current nested is a RIGHT JOIN, the operands in
-      'join_list' are in reverse order, thus the last operand is in the
-      end of the list.
-    */
-    if ((cur_table_ref->outer_join & JOIN_TYPE_RIGHT))
-    {
-      List_iterator_fast<TableList> it(cur_nested_join->join_list);
-      TableList *next;
-      cur_table_ref= it++;
-      while ((next= it++))
-        cur_table_ref= next;
-    }
-    if (cur_table_ref->is_leaf_for_name_resolution())
-      break;
-  }
-  return cur_table_ref;
-}
-
-
 /*****************************************************************************
   Functions to handle column usage bitmaps (read_set, write_set etc...)
 *****************************************************************************/
@@ -2384,192 +2160,6 @@
     mark_auto_increment_column();
 }
 
-/*
-  Return subselect that contains the FROM list this table is taken from
-
-  SYNOPSIS
-    TableList::containing_subselect()
-
-  RETURN
-    Subselect item for the subquery that contains the FROM list
-    this table is taken from if there is any
-    0 - otherwise
-
-*/
-
-Item_subselect *TableList::containing_subselect()
-{
-  return (select_lex ? select_lex->master_unit()->item : 0);
-}
-
-/*
-  Compiles the tagged hints list and fills up the bitmasks.
-
-  SYNOPSIS
-    process_index_hints()
-      table         the Table to operate on.
-
-  DESCRIPTION
-    The parser collects the index hints for each table in a "tagged list"
-    (TableList::index_hints). Using the information in this tagged list
-    this function sets the members Table::keys_in_use_for_query,
-    Table::keys_in_use_for_group_by, Table::keys_in_use_for_order_by,
-    Table::force_index and Table::covering_keys.
-
-    Current implementation of the runtime does not allow mixing FORCE INDEX
-    and USE INDEX, so this is checked here. Then the FORCE INDEX list
-    (if non-empty) is appended to the USE INDEX list and a flag is set.
-
-    Multiple hints of the same kind are processed so that each clause
-    is applied to what is computed in the previous clause.
-    For example:
-        USE INDEX (i1) USE INDEX (i2)
-    is equivalent to
-        USE INDEX (i1,i2)
-    and means "consider only i1 and i2".
-
-    Similarly
-        USE INDEX () USE INDEX (i1)
-    is equivalent to
-        USE INDEX (i1)
-    and means "consider only the index i1"
-
-    It is OK to have the same index several times, e.g. "USE INDEX (i1,i1)" is
-    not an error.
-
-    Different kind of hints (USE/FORCE/IGNORE) are processed in the following
-    order:
-      1. All indexes in USE (or FORCE) INDEX are added to the mask.
-      2. All IGNORE INDEX
-
-    e.g. "USE INDEX i1, IGNORE INDEX i1, USE INDEX i1" will not use i1 at all
-    as if we had "USE INDEX i1, USE INDEX i1, IGNORE INDEX i1".
-
-    As an optimization if there is a covering index, and we have
-    IGNORE INDEX FOR GROUP/order_st, and this index is used for the JOIN part,
-    then we have to ignore the IGNORE INDEX FROM GROUP/order_st.
-
-  RETURN VALUE
-    false                no errors found
-    TRUE                 found and reported an error.
-*/
-bool TableList::process_index_hints(Table *tbl)
-{
-  /* initialize the result variables */
-  tbl->keys_in_use_for_query= tbl->keys_in_use_for_group_by=
-    tbl->keys_in_use_for_order_by= tbl->s->keys_in_use;
-
-  /* index hint list processing */
-  if (index_hints)
-  {
-    key_map index_join[INDEX_HINT_FORCE + 1];
-    key_map index_order[INDEX_HINT_FORCE + 1];
-    key_map index_group[INDEX_HINT_FORCE + 1];
-    Index_hint *hint;
-    int type;
-    bool have_empty_use_join= false, have_empty_use_order= false,
-         have_empty_use_group= false;
-    List_iterator <Index_hint> iter(*index_hints);
-
-    /* initialize temporary variables used to collect hints of each kind */
-    for (type= INDEX_HINT_IGNORE; type <= INDEX_HINT_FORCE; type++)
-    {
-      index_join[type].reset();
-      index_order[type].reset();
-      index_group[type].reset();
-    }
-
-    /* iterate over the hints list */
-    while ((hint= iter++))
-    {
-      uint32_t pos;
-
-      /* process empty USE INDEX () */
-      if (hint->type == INDEX_HINT_USE && !hint->key_name.str)
-      {
-        if (hint->clause & INDEX_HINT_MASK_JOIN)
-        {
-          index_join[hint->type].reset();
-          have_empty_use_join= true;
-        }
-        if (hint->clause & INDEX_HINT_MASK_ORDER)
-        {
-          index_order[hint->type].reset();
-          have_empty_use_order= true;
-        }
-        if (hint->clause & INDEX_HINT_MASK_GROUP)
-        {
-          index_group[hint->type].reset();
-          have_empty_use_group= true;
-        }
-        continue;
-      }
-
-      /*
-        Check if an index with the given name exists and get his offset in
-        the keys bitmask for the table
-      */
-      if (tbl->s->keynames.type_names == 0 ||
-          (pos= find_type(&tbl->s->keynames, hint->key_name.str,
-                          hint->key_name.length, 1)) <= 0)
-      {
-        my_error(ER_KEY_DOES_NOT_EXITS, MYF(0), hint->key_name.str, alias);
-        return 1;
-      }
-
-      pos--;
-
-      /* add to the appropriate clause mask */
-      if (hint->clause & INDEX_HINT_MASK_JOIN)
-        index_join[hint->type].set(pos);
-      if (hint->clause & INDEX_HINT_MASK_ORDER)
-        index_order[hint->type].set(pos);
-      if (hint->clause & INDEX_HINT_MASK_GROUP)
-        index_group[hint->type].set(pos);
-    }
-
-    /* cannot mix USE INDEX and FORCE INDEX */
-    if ((index_join[INDEX_HINT_FORCE].any() ||
-         index_order[INDEX_HINT_FORCE].any() ||
-         index_group[INDEX_HINT_FORCE].any()) &&
-        (index_join[INDEX_HINT_USE].any() ||  have_empty_use_join ||
-         index_order[INDEX_HINT_USE].any() || have_empty_use_order ||
-         index_group[INDEX_HINT_USE].any() || have_empty_use_group))
-    {
-      my_error(ER_WRONG_USAGE, MYF(0), index_hint_type_name[INDEX_HINT_USE],
-               index_hint_type_name[INDEX_HINT_FORCE]);
-      return 1;
-    }
-
-    /* process FORCE INDEX as USE INDEX with a flag */
-    if (index_join[INDEX_HINT_FORCE].any() ||
-        index_order[INDEX_HINT_FORCE].any() ||
-        index_group[INDEX_HINT_FORCE].any())
-    {
-      tbl->force_index= true;
-      index_join[INDEX_HINT_USE]|= index_join[INDEX_HINT_FORCE];
-      index_order[INDEX_HINT_USE]|= index_order[INDEX_HINT_FORCE];
-      index_group[INDEX_HINT_USE]|= index_group[INDEX_HINT_FORCE];
-    }
-
-    /* apply USE INDEX */
-    if (index_join[INDEX_HINT_USE].any() || have_empty_use_join)
-      tbl->keys_in_use_for_query&= index_join[INDEX_HINT_USE];
-    if (index_order[INDEX_HINT_USE].any() || have_empty_use_order)
-      tbl->keys_in_use_for_order_by&= index_order[INDEX_HINT_USE];
-    if (index_group[INDEX_HINT_USE].any() || have_empty_use_group)
-      tbl->keys_in_use_for_group_by&= index_group[INDEX_HINT_USE];
-
-    /* apply IGNORE INDEX */
-    key_map_subtract(tbl->keys_in_use_for_query, index_join[INDEX_HINT_IGNORE]);
-    key_map_subtract(tbl->keys_in_use_for_order_by, index_order[INDEX_HINT_IGNORE]);
-    key_map_subtract(tbl->keys_in_use_for_group_by, index_group[INDEX_HINT_IGNORE]);
-  }
-
-  /* make sure covering_keys don't include indexes disabled with a hint */
-  tbl->covering_keys&= tbl->keys_in_use_for_query;
-  return 0;
-}
 
 
 size_t Table::max_row_length(const unsigned char *data)
@@ -3967,6 +3557,52 @@
 }
 
 
+/*
+  Find field in table, no side effects, only purpose is to check for field
+  in table object and get reference to the field if found.
+
+  SYNOPSIS
+  find_field_in_table_sef()
+
+  table                         table where to find
+  name                          Name of field searched for
+
+  RETURN
+  0                   field is not found
+#                   pointer to field
+*/
+
+Field *Table::find_field_in_table_sef(const char *name)
+{
+  Field **field_ptr;
+  if (s->name_hash.records)
+  {
+    field_ptr= (Field**)hash_search(&s->name_hash,(unsigned char*) name,
+                                    strlen(name));
+    if (field_ptr)
+    {
+      /*
+        field_ptr points to field in TableShare. Convert it to the matching
+        field in table
+      */
+      field_ptr= (field + (field_ptr - s->field));
+    }
+  }
+  else
+  {
+    if (!(field_ptr= field))
+      return (Field *)0;
+    for (; *field_ptr; ++field_ptr)
+      if (!my_strcasecmp(system_charset_info, (*field_ptr)->field_name, name))
+        break;
+  }
+  if (field_ptr)
+    return *field_ptr;
+  else
+    return (Field *)0;
+}
+
+
 /*****************************************************************************
 ** Instansiate templates
 *****************************************************************************/

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-06-04 19:00:08 +0000
+++ drizzled/table.h	2009-06-08 06:23:32 +0000
@@ -516,6 +516,7 @@
     status|=STATUS_NULL_ROW;
     memset(null_flags, 255, s->null_bytes);
   }
+  Field *find_field_in_table_sef(const char *name);
 
 };
 

=== added file 'drizzled/table_list.cc'
--- drizzled/table_list.cc	1970-01-01 00:00:00 +0000
+++ drizzled/table_list.cc	2009-06-08 06:23:32 +0000
@@ -0,0 +1,553 @@
+/* Copyright (C) 2009 Sun Microsystems
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; version 2 of the License.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License
+  along with this program; if not, write to the Free Software
+  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
+
+#include <drizzled/error.h>
+#include <drizzled/table_list.h>
+#include <drizzled/item.h>
+#include <drizzled/item/field.h>
+#include <drizzled/nested_join.h>
+#include <drizzled/sql_lex.h>
+#include <drizzled/server_includes.h>
+#include <drizzled/sql_select.h>
+
+#include <string>
+
+using namespace std;
+
+class Item;
+class Item_field;
+
+/*
+  Create a table cache key
+
+  SYNOPSIS
+  create_table_def_key()
+  key			Create key here (must be of size MAX_DBKEY_LENGTH)
+  table_list		Table definition
+
+  IMPLEMENTATION
+  The table cache_key is created from:
+  db_name + \0
+  table_name + \0
+
+  if the table is a tmp table, we add the following to make each tmp table
+  unique on the slave:
+
+  4 bytes for master thread id
+  4 bytes pseudo thread id
+
+  RETURN
+  Length of key
+*/
+
+uint32_t TableList::create_table_def_key(char *key)
+{
+  uint32_t key_length;
+  char *key_pos= key;
+
+  key_pos= strcpy(key_pos, db) + strlen(db);
+  key_pos= strcpy(key_pos+1, table_name) +
+    strlen(table_name);
+  key_length= (uint32_t)(key_pos-key)+1;
+
+  return key_length;
+}
+
+
+/*
+  Set insert_values buffer
+
+  SYNOPSIS
+    set_insert_values()
+    mem_root   memory pool for allocating
+
+  RETURN
+    false - OK
+    TRUE  - out of memory
+*/
+
+bool TableList::set_insert_values(MEM_ROOT *mem_root)
+{
+  if (table)
+  {
+    if (!table->insert_values &&
+        !(table->insert_values= (unsigned char *)alloc_root(mem_root,
+                                                   table->s->rec_buff_length)))
+      return true;
+  }
+
+  return false;
+}
+
+
+/*
+  Test if this is a leaf with respect to name resolution.
+
+  SYNOPSIS
+    TableList::is_leaf_for_name_resolution()
+
+  DESCRIPTION
+    A table reference is a leaf with respect to name resolution if
+    it is either a leaf node in a nested join tree (table, view,
+    schema table, subquery), or an inner node that represents a
+    NATURAL/USING join, or a nested join with materialized join
+    columns.
+
+  RETURN
+    TRUE if a leaf, false otherwise.
+*/
+bool TableList::is_leaf_for_name_resolution()
+{
+  return (is_natural_join || is_join_columns_complete || !nested_join);
+}
+
+
+
+/*
+  Create Item_field for each column in the table.
+
+  SYNPOSIS
+    Table::fill_item_list()
+      item_list          a pointer to an empty list used to store items
+
+  DESCRIPTION
+    Create Item_field object for each column in the table and
+    initialize it with the corresponding Field. New items are
+    created in the current Session memory root.
+
+  RETURN VALUE
+    0                    success
+    1                    out of memory
+*/
+
+bool Table::fill_item_list(List<Item> *item_list) const
+{
+  /*
+    All Item_field's created using a direct pointer to a field
+    are fixed in Item_field constructor.
+  */
+  for (Field **ptr= field; *ptr; ptr++)
+  {
+    Item_field *item= new Item_field(*ptr);
+    if (!item || item_list->push_back(item))
+      return true;
+  }
+  return false;
+}
+
+
+/*
+  Find underlying base tables (TableList) which represent given
+  table_to_find (Table)
+
+  SYNOPSIS
+    TableList::find_underlying_table()
+    table_to_find table to find
+
+  RETURN
+    0  table is not found
+    found table reference
+*/
+
+TableList *TableList::find_underlying_table(Table *table_to_find)
+{
+  /* is this real table and table which we are looking for? */
+  if (table == table_to_find)
+    return this;
+
+  return NULL;
+}
+
+
+bool TableList::placeholder()
+{
+  return derived || schema_table || (create && !table->getDBStat()) || !table;
+}
+
+
+/*
+  Retrieve the last (right-most) leaf in a nested join tree with
+  respect to name resolution.
+
+  SYNOPSIS
+    TableList::last_leaf_for_name_resolution()
+
+  DESCRIPTION
+    Given that 'this' is a nested table reference, recursively walk
+    down the right-most children of 'this' until we reach a leaf
+    table reference with respect to name resolution.
+
+  IMPLEMENTATION
+    The right-most child of a nested table reference is the first
+    element in the list of children because the children are inserted
+    in reverse order.
+
+  RETURN
+    - If 'this' is a nested table reference - the right-most child of
+      the tree rooted in 'this',
+    - else - 'this'
+*/
+
+TableList *TableList::last_leaf_for_name_resolution()
+{
+  TableList *cur_table_ref= this;
+  nested_join_st *cur_nested_join;
+
+  if (is_leaf_for_name_resolution())
+    return this;
+  assert(nested_join);
+
+  for (cur_nested_join= nested_join;
+       cur_nested_join;
+       cur_nested_join= cur_table_ref->nested_join)
+  {
+    cur_table_ref= cur_nested_join->join_list.head();
+    /*
+      If the current nested is a RIGHT JOIN, the operands in
+      'join_list' are in reverse order, thus the last operand is in the
+      end of the list.
+    */
+    if ((cur_table_ref->outer_join & JOIN_TYPE_RIGHT))
+    {
+      List_iterator_fast<TableList> it(cur_nested_join->join_list);
+      TableList *next;
+      cur_table_ref= it++;
+      while ((next= it++))
+        cur_table_ref= next;
+    }
+    if (cur_table_ref->is_leaf_for_name_resolution())
+      break;
+  }
+  return cur_table_ref;
+}
+
+
+/*
+  Retrieve the first (left-most) leaf in a nested join tree with
+  respect to name resolution.
+
+  SYNOPSIS
+    TableList::first_leaf_for_name_resolution()
+
+  DESCRIPTION
+    Given that 'this' is a nested table reference, recursively walk
+    down the left-most children of 'this' until we reach a leaf
+    table reference with respect to name resolution.
+
+  IMPLEMENTATION
+    The left-most child of a nested table reference is the last element
+    in the list of children because the children are inserted in
+    reverse order.
+
+  RETURN
+    If 'this' is a nested table reference - the left-most child of
+      the tree rooted in 'this',
+    else return 'this'
+*/
+
+TableList *TableList::first_leaf_for_name_resolution()
+{
+  TableList *cur_table_ref= NULL;
+  nested_join_st *cur_nested_join;
+
+  if (is_leaf_for_name_resolution())
+    return this;
+  assert(nested_join);
+
+  for (cur_nested_join= nested_join;
+       cur_nested_join;
+       cur_nested_join= cur_table_ref->nested_join)
+  {
+    List_iterator_fast<TableList> it(cur_nested_join->join_list);
+    cur_table_ref= it++;
+    /*
+      If the current nested join is a RIGHT JOIN, the operands in
+      'join_list' are in reverse order, thus the first operand is
+      already at the front of the list. Otherwise the first operand
+      is in the end of the list of join operands.
+    */
+    if (!(cur_table_ref->outer_join & JOIN_TYPE_RIGHT))
+    {
+      TableList *next;
+      while ((next= it++))
+        cur_table_ref= next;
+    }
+    if (cur_table_ref->is_leaf_for_name_resolution())
+      break;
+  }
+  return cur_table_ref;
+}
+
+
+/*
+  Return subselect that contains the FROM list this table is taken from
+
+  SYNOPSIS
+    TableList::containing_subselect()
+
+  RETURN
+    Subselect item for the subquery that contains the FROM list
+    this table is taken from if there is any
+    0 - otherwise
+
+*/
+
+Item_subselect *TableList::containing_subselect()
+{
+  return (select_lex ? select_lex->master_unit()->item : 0);
+}
+
+
+/*
+  Compiles the tagged hints list and fills up the bitmasks.
+
+  SYNOPSIS
+    process_index_hints()
+      table         the Table to operate on.
+
+  DESCRIPTION
+    The parser collects the index hints for each table in a "tagged list"
+    (TableList::index_hints). Using the information in this tagged list
+    this function sets the members Table::keys_in_use_for_query,
+    Table::keys_in_use_for_group_by, Table::keys_in_use_for_order_by,
+    Table::force_index and Table::covering_keys.
+
+    Current implementation of the runtime does not allow mixing FORCE INDEX
+    and USE INDEX, so this is checked here. Then the FORCE INDEX list
+    (if non-empty) is appended to the USE INDEX list and a flag is set.
+
+    Multiple hints of the same kind are processed so that each clause
+    is applied to what is computed in the previous clause.
+    For example:
+        USE INDEX (i1) USE INDEX (i2)
+    is equivalent to
+        USE INDEX (i1,i2)
+    and means "consider only i1 and i2".
+
+    Similarly
+        USE INDEX () USE INDEX (i1)
+    is equivalent to
+        USE INDEX (i1)
+    and means "consider only the index i1"
+
+    It is OK to have the same index several times, e.g. "USE INDEX (i1,i1)" is
+    not an error.
+
+    Different kind of hints (USE/FORCE/IGNORE) are processed in the following
+    order:
+      1. All indexes in USE (or FORCE) INDEX are added to the mask.
+      2. All IGNORE INDEX
+
+    e.g. "USE INDEX i1, IGNORE INDEX i1, USE INDEX i1" will not use i1 at all
+    as if we had "USE INDEX i1, USE INDEX i1, IGNORE INDEX i1".
+
+    As an optimization if there is a covering index, and we have
+    IGNORE INDEX FOR GROUP/order_st, and this index is used for the JOIN part,
+    then we have to ignore the IGNORE INDEX FROM GROUP/order_st.
+
+  RETURN VALUE
+    false                no errors found
+    TRUE                 found and reported an error.
+*/
+bool TableList::process_index_hints(Table *tbl)
+{
+  /* initialize the result variables */
+  tbl->keys_in_use_for_query= tbl->keys_in_use_for_group_by=
+    tbl->keys_in_use_for_order_by= tbl->s->keys_in_use;
+
+  /* index hint list processing */
+  if (index_hints)
+  {
+    key_map index_join[INDEX_HINT_FORCE + 1];
+    key_map index_order[INDEX_HINT_FORCE + 1];
+    key_map index_group[INDEX_HINT_FORCE + 1];
+    Index_hint *hint;
+    int type;
+    bool have_empty_use_join= false, have_empty_use_order= false,
+         have_empty_use_group= false;
+    List_iterator <Index_hint> iter(*index_hints);
+
+    /* initialize temporary variables used to collect hints of each kind */
+    for (type= INDEX_HINT_IGNORE; type <= INDEX_HINT_FORCE; type++)
+    {
+      index_join[type].reset();
+      index_order[type].reset();
+      index_group[type].reset();
+    }
+
+    /* iterate over the hints list */
+    while ((hint= iter++))
+    {
+      uint32_t pos;
+
+      /* process empty USE INDEX () */
+      if (hint->type == INDEX_HINT_USE && !hint->key_name.str)
+      {
+        if (hint->clause & INDEX_HINT_MASK_JOIN)
+        {
+          index_join[hint->type].reset();
+          have_empty_use_join= true;
+        }
+        if (hint->clause & INDEX_HINT_MASK_ORDER)
+        {
+          index_order[hint->type].reset();
+          have_empty_use_order= true;
+        }
+        if (hint->clause & INDEX_HINT_MASK_GROUP)
+        {
+          index_group[hint->type].reset();
+          have_empty_use_group= true;
+        }
+        continue;
+      }
+
+      /*
+        Check if an index with the given name exists and get his offset in
+        the keys bitmask for the table
+      */
+      if (tbl->s->keynames.type_names == 0 ||
+          (pos= find_type(&tbl->s->keynames, hint->key_name.str,
+                          hint->key_name.length, 1)) <= 0)
+      {
+        my_error(ER_KEY_DOES_NOT_EXITS, MYF(0), hint->key_name.str, alias);
+        return 1;
+      }
+
+      pos--;
+
+      /* add to the appropriate clause mask */
+      if (hint->clause & INDEX_HINT_MASK_JOIN)
+        index_join[hint->type].set(pos);
+      if (hint->clause & INDEX_HINT_MASK_ORDER)
+        index_order[hint->type].set(pos);
+      if (hint->clause & INDEX_HINT_MASK_GROUP)
+        index_group[hint->type].set(pos);
+    }
+
+    /* cannot mix USE INDEX and FORCE INDEX */
+    if ((index_join[INDEX_HINT_FORCE].any() ||
+         index_order[INDEX_HINT_FORCE].any() ||
+         index_group[INDEX_HINT_FORCE].any()) &&
+        (index_join[INDEX_HINT_USE].any() ||  have_empty_use_join ||
+         index_order[INDEX_HINT_USE].any() || have_empty_use_order ||
+         index_group[INDEX_HINT_USE].any() || have_empty_use_group))
+    {
+      my_error(ER_WRONG_USAGE, MYF(0), index_hint_type_name[INDEX_HINT_USE],
+               index_hint_type_name[INDEX_HINT_FORCE]);
+      return 1;
+    }
+
+    /* process FORCE INDEX as USE INDEX with a flag */
+    if (index_join[INDEX_HINT_FORCE].any() ||
+        index_order[INDEX_HINT_FORCE].any() ||
+        index_group[INDEX_HINT_FORCE].any())
+    {
+      tbl->force_index= true;
+      index_join[INDEX_HINT_USE]|= index_join[INDEX_HINT_FORCE];
+      index_order[INDEX_HINT_USE]|= index_order[INDEX_HINT_FORCE];
+      index_group[INDEX_HINT_USE]|= index_group[INDEX_HINT_FORCE];
+    }
+
+    /* apply USE INDEX */
+    if (index_join[INDEX_HINT_USE].any() || have_empty_use_join)
+      tbl->keys_in_use_for_query&= index_join[INDEX_HINT_USE];
+    if (index_order[INDEX_HINT_USE].any() || have_empty_use_order)
+      tbl->keys_in_use_for_order_by&= index_order[INDEX_HINT_USE];
+    if (index_group[INDEX_HINT_USE].any() || have_empty_use_group)
+      tbl->keys_in_use_for_group_by&= index_group[INDEX_HINT_USE];
+
+    /* apply IGNORE INDEX */
+    key_map_subtract(tbl->keys_in_use_for_query, index_join[INDEX_HINT_IGNORE]);
+    key_map_subtract(tbl->keys_in_use_for_order_by, index_order[INDEX_HINT_IGNORE]);
+    key_map_subtract(tbl->keys_in_use_for_group_by, index_group[INDEX_HINT_IGNORE]);
+  }
+
+  /* make sure covering_keys don't include indexes disabled with a hint */
+  tbl->covering_keys&= tbl->keys_in_use_for_query;
+  return 0;
+}
+
+
+/**
+  Print table as it should be in join list.
+
+  @param str   string where table should be printed
+*/
+void TableList::print(Session *session, String *str, enum_query_type query_type)
+{
+  if (nested_join)
+  {
+    str->append('(');
+    print_join(session, str, &nested_join->join_list, query_type);
+    str->append(')');
+  }
+  else
+  {
+    const char *cmp_name;                         // Name to compare with alias
+    if (derived)
+    {
+      // A derived table
+      str->append('(');
+      derived->print(str, query_type);
+      str->append(')');
+      cmp_name= "";                               // Force printing of alias
+    }
+    else
+    {
+      // A normal table
+      {
+        str->append_identifier(db, db_length);
+        str->append('.');
+      }
+      if (schema_table)
+      {
+        str->append_identifier(schema_table_name, strlen(schema_table_name));
+        cmp_name= schema_table_name;
+      }
+      else
+      {
+        str->append_identifier(table_name, table_name_length);
+        cmp_name= table_name;
+      }
+    }
+    if (my_strcasecmp(table_alias_charset, cmp_name, alias))
+    {
+
+      if (alias && alias[0])
+      {
+        str->append(' ');
+
+        string t_alias(alias);
+        transform(t_alias.begin(), t_alias.end(),
+                  t_alias.begin(), ::tolower);
+
+        str->append_identifier(t_alias.c_str(), t_alias.length());
+      }
+
+    }
+
+    if (index_hints)
+    {
+      List_iterator<Index_hint> it(*index_hints);
+      Index_hint *hint;
+
+      while ((hint= it++))
+      {
+        str->append (STRING_WITH_LEN(" "));
+        hint->print (session, str);
+      }
+    }
+  }
+}

=== modified file 'drizzled/table_list.h'
--- drizzled/table_list.h	2009-06-06 01:45:22 +0000
+++ drizzled/table_list.h	2009-06-08 06:23:32 +0000
@@ -282,7 +282,7 @@
   TableList *last_leaf_for_name_resolution();
   bool is_leaf_for_name_resolution();
   inline TableList *top_table()
-    { return this; }
+  { return this; }
 
   Item_subselect *containing_subselect();
 
@@ -292,6 +292,7 @@
     st_table::force_index and st_table::covering_keys.
   */
   bool process_index_hints(Table *table);
+  uint32_t create_table_def_key(char *key);
 };
 
 void close_thread_tables(Session *session);

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2009-06-05 18:49:23 +0000
+++ plugin/myisam/ha_myisam.cc	2009-06-08 16:51:22 +0000
@@ -875,8 +875,7 @@
   strcpy(fixed_name,file->filename);
 
   // Don't lock tables if we have used LOCK Table
-  if (!session->locked_tables &&
-      mi_lock_database(file, table->s->tmp_table ? F_EXTRA_LCK : F_WRLCK))
+  if (mi_lock_database(file, table->s->tmp_table ? F_EXTRA_LCK : F_WRLCK))
   {
     mi_check_print_error(&param,ER(ER_CANT_LOCK),my_errno);
     return(HA_ADMIN_FAILED);
@@ -985,8 +984,8 @@
     update_state_info(&param, file, 0);
   }
   session->set_proc_info(old_proc_info);
-  if (!session->locked_tables)
-    mi_lock_database(file,F_UNLCK);
+  mi_lock_database(file,F_UNLCK);
+
   return(error ? HA_ADMIN_FAILED :
 	      !optimize_done ? HA_ADMIN_ALREADY_DONE : HA_ADMIN_OK);
 }

